# NLopt.jl

[![Build Status](https://github.com/jump-dev/NLopt.jl/actions/workflows/ci.yml/badge.svg?branch=master)](https://github.com/jump-dev/NLopt.jl/actions?query=workflow%3ACI)
[![codecov](https://codecov.io/gh/jump-dev/NLopt.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/jump-dev/NLopt.jl)

[NLopt.jl](https://github.com/jump-dev/NLopt.jl) is a wrapper for the
[NLopt](https://nlopt.readthedocs.io/en/latest/) library for nonlinear
optimization.

NLopt provides a common interface for many different optimization algorithms,
including:

* Both global and local optimization
* Algorithms using function values only (derivative-free) and also algorithms
  exploiting user-supplied gradients.
* Algorithms for unconstrained optimization, bound-constrained optimization,
  and general nonlinear inequality/equality constraints.

## License

`NLopt.jl` is licensed under the [MIT License](https://github.com/jump-dev/NLopt.jl/blob/master/LICENSE.md).

The underlying solver, [stevengj/nlopt](https://github.com/stevengj/nlopt), is
licensed under the [LGPL v3.0 license](https://github.com/stevengj/nlopt/blob/master/COPYING).

## Installation

Install `NLopt.jl` using the Julia package manager:
```julia
import Pkg
Pkg.add("NLopt")
```

In addition to installing the `NLopt.jl` package, this will also download and
install the NLopt binaries. You do not need to install NLopt separately.

## Tutorial

The following example code solves the nonlinearly constrained minimization
problem from the [NLopt Tutorial](https://nlopt.readthedocs.io/en/latest/NLopt_Tutorial/).

```julia
using NLopt
function my_objective_fn(x::Vector, grad::Vector)
    if length(grad) > 0
        grad[1] = 0
        grad[2] = 0.5 / sqrt(x[2])
    end
    return sqrt(x[2])
end
function my_constraint_fn(x::Vector, grad::Vector, a, b)
    if length(grad) > 0
        grad[1] = 3 * a * (a * x[1] + b)^2
        grad[2] = -1
    end
    return (a * x[1] + b)^3 - x[2]
end
opt = NLopt.Opt(:LD_MMA, 2)
NLopt.lower_bounds!(opt, [-Inf, 0.0])
NLopt.xtol_rel!(opt, 1e-4)
NLopt.min_objective!(opt, my_objective_fn)
NLopt.inequality_constraint!(opt, (x, g) -> my_constraint_fn(x, g, 2, 0), 1e-8)
NLopt.inequality_constraint!(opt, (x, g) -> my_constraint_fn(x, g, -1, 1), 1e-8)
min_f, min_x, ret = NLopt.optimize(opt, [1.234, 5.678])
num_evals = NLopt.numevals(opt)
println(
    """
    objective value       : $min_f
    solution              : $min_x
    solution status       : $ret
    # function evaluation : $num_evals
    """
)
```

The output is:

```
objective value       : 0.5443310477213124
solution              : [0.3333333342139688, 0.29629628951338166]
solution status       : XTOL_REACHED
# function evaluation : 11
```

### Algorithm-specific parameters

Some algorithms have algorithm-specific parameters that can be set via
`NLopt.nlopt_set_param`. For example:

```julia
julia> import NLopt

julia> opt = NLopt.Opt(:LD_MMA, 2)
Opt(LD_MMA, 2)

julia> NLopt.nlopt_set_param(opt, "inner_maxeval", 5)
NLOPT_SUCCESS::nlopt_result = 1
```

Consult the [NLopt documentation](https://nlopt.readthedocs.io/en/latest/NLopt_Algorithms)
for the list of parameters supported by each algorithm.

### Trace iterations

A common feature request is for a callback that can used to trace the solution
over the iterations of the optimizer.

There is no native support for this in NLopt. Instead, add the callback to your
objective function.

```julia
julia> using NLopt

julia> begin
           trace = Any[]
           function my_objective_fn(x::Vector, grad::Vector)
               if length(grad) > 0
                   grad[1] = 0
                   grad[2] = 0.5 / sqrt(x[2])
               end
               value = sqrt(x[2])
               push!(trace, copy(x) => value)
               return value
           end
           function my_constraint_fn(x::Vector, grad::Vector, a, b)
               if length(grad) > 0
                   grad[1] = 3 * a * (a * x[1] + b)^2
                   grad[2] = -1
               end
               return (a * x[1] + b)^3 - x[2]
           end
           opt = NLopt.Opt(:LD_MMA, 2)
           NLopt.lower_bounds!(opt, [-Inf, 0.0])
           NLopt.xtol_rel!(opt, 1e-4)
           NLopt.min_objective!(opt, my_objective_fn)
           NLopt.inequality_constraint!(opt, (x, g) -> my_constraint_fn(x, g, 2, 0), 1e-8)
           NLopt.inequality_constraint!(opt, (x, g) -> my_constraint_fn(x, g, -1, 1), 1e-8)
           min_f, min_x, ret = NLopt.optimize(opt, [1.234, 5.678])
       end
(0.5443310477213124, [0.3333333342139688, 0.29629628951338166], :XTOL_REACHED)

julia> trace
11-element Vector{Any}:
                            [1.234, 5.678] => 2.382855429941145
   [0.8787394664016357, 5.551370325142423] => 2.3561346152421816
   [0.8262160034228196, 5.043903787432386] => 2.245863706334912
  [0.4739440370386794, 4.0767726724255375] => 2.0191019470114773
    [0.35389779634506047, 3.0308503583016] => 1.7409337604577608
 [0.33387310647853335, 1.9717933962872487] => 1.4042056104029954
  [0.3333337209575201, 1.0450874902862517] => 1.0222952070152005
 [0.33333357431034494, 0.4695027039311135] => 0.6852026736164369
  [0.3333332772332185, 0.3057923933552822] => 0.5529849847466767
 [0.33333339455750244, 0.2963215980646768] => 0.5443542946139737
 [0.3333333342139688, 0.29629628951338166] => 0.5443310477213124
```

## Use with JuMP

NLopt implements the [MathOptInterface interface](https://jump.dev/MathOptInterface.jl/stable/reference/nonlinear/)
for nonlinear optimization, which means that it can be used interchangeably with
other optimization packages from modeling packages like
[JuMP](https://github.com/jump-dev/JuMP.jl). Note that NLopt does not exploit
sparsity of Jacobians.

You can use NLopt with JuMP as follows:
```julia
using JuMP, NLopt
model = Model(NLopt.Optimizer)
set_attribute(model, "algorithm", :LD_MMA)
set_attribute(model, "xtol_rel", 1e-4)
set_attribute(model, "constrtol_abs", 1e-8)
@variable(model, x[1:2])
set_lower_bound(x[2], 0.0)
set_start_value.(x, [1.234, 5.678])
@NLobjective(model, Min, sqrt(x[2]))
@NLconstraint(model, (2 * x[1] + 0)^3 - x[2] <= 0)
@NLconstraint(model, (-1 * x[1] + 1)^3 - x[2] <= 0)
optimize!(model)
min_f, min_x, ret = objective_value(model), value.(x), raw_status(model)
println(
    """
    objective value       : $min_f
    solution              : $min_x
    solution status       : $ret
    """
)
```

The output is:

```
objective value       : 0.5443310477213124
solution              : [0.3333333342139688, 0.29629628951338166]
solution status       : XTOL_REACHED
```


The `algorithm` attribute is required. The value must be one of the supported
[NLopt algorithms](https://nlopt.readthedocs.io/en/latest/NLopt_Algorithms/).

Other parameters include `stopval`, `ftol_rel`, `ftol_abs`, `xtol_rel`,
`xtol_abs`, `constrtol_abs`, `maxeval`, `maxtime`, `initial_step`, `population`,
`seed`, and `vector_storage`.

The ``algorithm`` parameter is required, and all others are optional. The
meaning and acceptable values of all parameters, except `constrtol_abs`, match
the descriptions below from the specialized NLopt API.

The `constrtol_abs` parameter is an absolute feasibility tolerance applied to
all constraints.

## Automatic differentiation

Some algorithms in NLopt require derivatives, which you must manually provide
in the `if length(grad) > 0` branch of your objective and constraint functions.

To stay simple and lightweight, NLopt does not provide ways to automatically
compute derivatives. If you do not have analytic expressions for the derivatives,
use a package such as [ForwardDiff.jl](https://github.com/JuliaDiff/ForwardDiff.jl)
to compute automatic derivatives.

Here is an example of how to wrap a function `f(x::Vector)` using ForwardDiff so
that it is compatible with NLopt:
```julia
using NLopt
import ForwardDiff
function autodiff(f::Function)
    function nlopt_fn(x::Vector, grad::Vector)
        if length(grad) > 0
            # Use ForwardDiff to compute the gradient. Replace with your
            # favorite Julia automatic differentiation package.
            ForwardDiff.gradient!(grad, f, x)
        end
        return f(x)
    end
end
# These functions do not implement `grad`:
my_objective_fn(x::Vector) = sqrt(x[2]);
my_constraint_fn(x::Vector, a, b) = (a * x[1] + b)^3 - x[2];
opt = NLopt.Opt(:LD_MMA, 2)
NLopt.lower_bounds!(opt, [-Inf, 0.0])
NLopt.xtol_rel!(opt, 1e-4)
# But we wrap them in autodiff before passing to NLopt:
NLopt.min_objective!(opt, autodiff(my_objective_fn))
NLopt.inequality_constraint!(opt, autodiff(x -> my_constraint_fn(x, 2, 0)), 1e-8)
NLopt.inequality_constraint!(opt, autodiff(x -> my_constraint_fn(x, -1, 1)), 1e-8)
min_f, min_x, ret = NLopt.optimize(opt, [1.234, 5.678])
# (0.5443310477213124, [0.3333333342139688, 0.29629628951338166], :XTOL_REACHED)
```

## Reference

The main purpose of this section is to document the syntax and unique features
of the Julia interface. For more detail on the underlying features, please refer
to the C documentation in the [NLopt Reference](https://nlopt.readthedocs.io/en/latest/NLopt_Reference/).

### Using the Julia API

To use NLopt in Julia, your Julia program should include the line:
```julia
using NLopt
```
which imports the NLopt module and its symbols.  Alternatively, you can use
`import NLopt` if you want to keep all the NLopt symbols in their own namespace.
You would then prefix all functions below with `NLopt.`, for example `NLopt.Opt` and so
on.

### The `Opt` type

The NLopt API revolves around an object of type `Opt`.

The object should normally be created via the constructor:
```julia
opt = Opt(algorithm::Symbol, n::Int)
```
given an algorithm (see [NLopt Algorithms](https://nlopt.readthedocs.io/en/latest/NLopt_Algorithms/)
for possible values) and the dimensionality of the problem (`n`, the number of
optimization parameters).

Whereas in C the algorithms are specified by `nlopt_algorithm` constants of the
form like `NLOPT_LD_MMA`, the Julia `algorithm` values are symbols of the form
`:LD_MMA` with the `NLOPT_` prefix replaced by `:` to create a Julia symbol.

There is also a `copy(opt::Opt)` function to make a copy of a given object
(equivalent to `nlopt_copy` in the C API).

If there is an error in these functions, an exception is thrown.

The algorithm and dimension parameters of the object are immutable (cannot be
changed without constructing a new object). Query them using:
```julia
ndims(opt::Opt)
algorithm(opt::Opt)
```

Get a string description of the algorithm via:
```julia
algorithm_name(opt::Opt)
```

### Objective function

The objective function is specified by calling one of:
```julia
min_objective!(opt::Opt, f::Function)
max_objective!(opt::Opt, f::Function)
```
depending on whether one wishes to minimize or maximize the objective function
`f`, respectively.

The function `f` must be of the form:
```julia
function f(x::Vector{Float64}, grad::Vector{Float64})
    if length(grad) > 0
        ...set grad to gradient, in-place...
    end
    return ...value of f(x)...
end
```

The return value must be the value of the function at the point `x`, where `x`
is a `Vector{Float64}` array of length `n` of the optimization parameters.

In addition, if the argument `grad` is not empty (that is, `length(grad) > 0`),
then `grad` is a `Vector{Float64}` array of length `n` which should (upon
return) be set to the gradient of the function with respect to the optimization
parameters at `x`.

Not all of the optimization algorithms (below) use the gradient information: for
algorithms listed as "derivative-free," the `grad` argument will always be empty
and need never be computed. For algorithms that do use gradient information,
`grad` may still be empty for some calls.

Note that `grad` must be modified *in-place* by your function `f`. Generally,
this means using indexing operations `grad[...] = ...` to overwrite the contents
of `grad`.  For example `grad = 2x` will *not* work, because it points `grad` to
a new array `2x` rather than overwriting the old contents; instead, use an
explicit loop or use `grad[:] = 2x`.

### Bound constraints

Add bound constraints with:
```julia
lower_bounds!(opt::Opt, lb::Union{AbstractVector,Real})
upper_bounds!(opt::Opt, ub::Union{AbstractVector,Real})
```
where `lb` and `ub` are real arrays of length `n` (the same as the dimension
passed to the `Opt` constructor).

For convenience, you can instead use a single scalar for `lb` or `ub` in order
to set the lower/upper bounds for all optimization parameters to a single
constant.

To retrieve the values of the lower or upper bounds, use:
```julia
lower_bounds(opt::Opt)
upper_bounds(opt::Opt)
```
both of which return `Vector{Float64}` arrays.

To specify an unbounded dimension, you can use `Inf` or `-Inf`.

### Nonlinear constraints

Specify nonlinear inequality and equality constraints by the functions:
```julia
inequality_constraint!(opt::Opt, f::Function, tol::Real = 0.0)
equality_constraint!(opt::Opt, f::Function, tol::Real = 0.0)
```
where the arguments `f` have the same form as the objective function above.

The optional `tol` arguments specify a tolerance (which defaults to zero) that
is used to judge feasibility for the purposes of stopping the optimization.

Each call to these function *adds* a new constraint to the set of constraints,
rather than replacing the constraints.

Remove all of the inequality and equality constraints from a given problem with:
```julia
remove_constraints!(opt::Opt)
```

### Vector-valued constraints

Specify vector-valued nonlinear inequality and equality constraints by the
functions:
```julia
inequality_constraint!(opt::Opt, f::Function, tol::AbstractVector)
equality_constraint!(opt::Opt, f::Function, tol::AbstractVector)
```
where `tol` is an array of the tolerances in each constraint dimension; the
dimensionality `m` of the constraint is determined by `length(tol)`.

The constraint function `f` must be of the form:
```julia
function f(result::Vector{Float64}, x::Vector{Float64}, grad::Matrix{Float64})
    if length(grad) > 0
        ...set grad to gradient, in-place...
    end
    result[1] = ...value of c1(x)...
    result[2] = ...value of c2(x)...
    return
```
where  `result` is a `Vector{Float64}` array whose length equals the
dimensionality `m` of the constraint (same as the length of `tol` above), which
upon return, should be set *in-place* to the constraint results at the point `x`.
Any return value of the function is ignored.

In addition, if the argument `grad` is not empty (that is, `length(grad) > 0`),
then `grad` is a matrix of size `n`&times;`m` which should (upon return) be
set in-place (see above) to the gradient of the function with respect to the
optimization parameters at `x`. That is, `grad[j,i]` should upon return contain
the partial derivative &part;f<sub>`i`</sub>/&part;x<sub>`j`</sub>.

A full example is:
```julia
julia> using NLopt

julia> function my_objective_fn(x::Vector, grad::Vector)
           if length(grad) > 0
               grad[1] = 0
               grad[2] = 0.5 / sqrt(x[2])
           end
           return sqrt(x[2])
       end
my_objective_fn (generic function with 1 method)

julia> function my_constraint_fn(x::Vector, grad::Vector, a, b)
           if length(grad) > 0
               grad[1] = 3 * a * (a * x[1] + b)^2
               grad[2] = -1
           end
           return (a * x[1] + b)^3 - x[2]
       end
my_constraint_fn (generic function with 1 method)

julia> function constraints(result::Vector, x::Vector, grad::Matrix)
           ∇g1 = [0.0, 0.0]
           ∇g2 = [0.0, 0.0]
           result[1] = my_constraint_fn(x, ∇g1, 2, 0)
           result[2] = my_constraint_fn(x, ∇g2, -1, 1)
           if length(grad) > 0
               # Note the `.=`. You must modify `grad` in-place
               grad .= vcat(∇g1', ∇g1')
           end
           return
       end
constraints (generic function with 2 methods)

julia> opt = NLopt.Opt(:LD_MMA, 2)
Opt(LD_MMA, 2)

julia> NLopt.lower_bounds!(opt, [-Inf, 0.0])

julia> NLopt.xtol_rel!(opt, 1e-6)

julia> NLopt.min_objective!(opt, my_objective_fn)

julia> NLopt.inequality_constraint!(opt, constraints, fill(1e-8, 2))

julia> min_f, min_x, ret = NLopt.optimize(opt, [1.234, 5.678])
(0.5443310692851157, [0.33333332182948433, 0.29629631298907744], :XTOL_REACHED)

julia> num_evals = NLopt.numevals(opt)
45

julia> println(
           """
           objective value       : $min_f
           solution              : $min_x
           solution status       : $ret
           # function evaluation : $num_evals
           """
       )
objective value       : 0.5443310692851157
solution              : [0.33333332182948433, 0.29629631298907744]
solution status       : XTOL_REACHED
# function evaluation : 45
```

Not all of the optimization algorithms (below) use the gradient information: for
algorithms listed as "derivative-free," the `grad` argument will always be empty
and need never be computed. For algorithms that do use gradient information,
`grad` may still be empty for some calls.

You can add multiple vector-valued constraints and/or scalar constraints in the
same problem.

### Stopping criteria

As explained in the [C API Reference](https://nlopt.readthedocs.io/en/latest/NLopt_Reference/)
and the [Introduction](https://nlopt.readthedocs.io/en/latest/NLopt_Introduction/),
you have multiple options for different stopping criteria that you can specify.
(Unspecified stopping criteria are disabled; that is, they have innocuous
defaults.)

For each stopping criteria, there are two functions that you can use to get and
set the value of the stopping criterion.

```julia
stopval(opt::Opt)          # return the current value of `stopval`
stopval!(opt::Opt, value)  # set stopval to `value`
```
Stop when an objective value of at least `stopval` is found. (Defaults to `-Inf`.)

```julia
ftol_rel(opt::Opt)
ftol_rel!(opt::Opt, value)
```
Relative tolerance on function value. (Defaults to `0`.)

```julia
ftol_abs(opt::Opt)
ftol_abs!(opt::Opt, value)
```
Absolute tolerance on function value. (Defaults to `0`.)

```julia
xtol_rel(opt::Opt)
xtol_rel!(opt::Opt, value)
```
Relative tolerances on the optimization parameters. (Defaults to `0`.)

```julia
xtol_abs(opt::Opt)
xtol_abs!(opt::Opt, value)
```
Absolute tolerances on the optimization parameters. (Defaults to `0`.)

In the case of `xtol_abs`, you can either set it to a scalar (to use the same
tolerance for all inputs) or a vector of length `n` (the dimension specified in
the `Opt` constructor) to use a different tolerance for each parameter.

```julia
maxeval(opt::Opt)
maxeval!(opt::Opt, value)
```
Stop when the number of function evaluations exceeds `mev`. (0 or negative for
no limit, which is the default.)

```julia
maxtime(opt::Opt)
maxtime!(opt::Opt, value)
```
Stop when the optimization time (in seconds) exceeds `t`. (0 or negative for no
limit, which is the default.)

### Forced termination

In certain cases, the caller may wish to force the optimization to halt, for
some reason unknown to NLopt. For example, if the user presses Ctrl-C, or there
is an error of some sort in the objective function. You can do this by throwing
any exception inside your objective/constraint functions: the optimization will
be halted gracefully, and the same exception will be thrown to the caller. The
Julia equivalent of `nlopt_forced_stop` from the C API is to throw a `ForcedStop`
exception.

### Performing the optimization

Once all of the desired optimization parameters have been specified in a given
object `opt::Opt`, you can perform the optimization by calling:
```julia
optf, optx, ret = optimize(opt::Opt, x::AbstractVector)
```

On input, `x` is an array of length `n` (the dimension of the problem from the
`Opt` constructor) giving an initial guess for the optimization parameters. The
return value `optx` is a array containing the optimized values of the
optimization parameters. `optf` contains the optimized value of the objective
function, and `ret` contains a symbol indicating the NLopt return code (below).

Alternatively:
```julia
optf, optx, ret = optimize!(opt::Opt, x::Vector{Float64})
```
is the same but modifies `x` in-place (as well as returning `optx = x`).

### Return values

The possible return values are the same as the [return values in the C API](https://nlopt.readthedocs.io/en/latest/NLopt_Reference/#Return_values),
except that the `NLOPT_` prefix is replaced with `:`.  That is, the return
values are like `:SUCCESS` instead `NLOPT_SUCCESS`.

### Local/subsidiary optimization algorithm

Some of the algorithms, especially `MLSL` and `AUGLAG`, use a different
optimization algorithm as a subroutine, typically for local optimization. You
can change the local search algorithm and its tolerances by setting:
```julia
local_optimizer!(opt::Opt, local_opt::Opt)
```

Here, `local_opt` is another `Opt` object whose parameters are used to determine
the local search algorithm, its stopping criteria, and other algorithm
parameters. (However, the objective function, bounds, and nonlinear-constraint
parameters of `local_opt` are ignored.) The dimension `n` of `local_opt` must
match that of `opt`.

This makes a copy of the `local_opt` object, so you can freely change your
original `local_opt` afterwards without affecting `opt`.

### Initial step size

Just [as in the C API](https://nlopt.readthedocs.io/en/latest/NLopt_Reference/#Initial_step_size),
you can set the initial step sizes for derivative-free optimization algorithms
with:
```julia
initial_step!(opt::Opt, dx::Vector)
```
Here, `dx` is an array of the (nonzero) initial steps for each dimension, or a
single number if you wish to use the same initial steps for all dimensions.

`initial_step(opt::Opt, x::AbstractVector)` returns the initial step that will
be used for a starting guess of `x` in `optimize(opt, x)`.

### Stochastic population

Just [as in the C API](https://nlopt.readthedocs.io/en/latest/NLopt_Reference/#Stochastic_population),
you can get and set the initial population for stochastic optimization with:
```julia
population(opt::Opt)
population!(opt::Opt, value)
```
A `population` of zero, the default, implies that the heuristic default will be
used as decided upon by individual algorithms.

### Pseudorandom numbers

For stochastic optimization algorithms, NLopt uses pseudorandom numbers
generated by the Mersenne Twister algorithm, based on code from Makoto Matsumoto.

By default, the seed for the random numbers is generated from the system time,
so that you will get a different sequence of pseudorandom numbers each time you
run your program. If you want to use a "deterministic" sequence of pseudorandom
numbers, that is, the same sequence from run to run, you can set the seed by
calling:
```julia
NLopt.srand(seed::Integer)
```
To reset the seed based on the system time, you can call `NLopt.srand_time()`.

Normally, you don't need to call this as it is called automatically. However, it
might be useful if you want to "re-randomize" the pseudorandom numbers after
calling `nlopt.srand` to set a deterministic seed.

### Vector storage for limited-memory quasi-Newton algorithms

Just [as in the C API](https://nlopt.readthedocs.io/en/latest/NLopt_Reference/#Vector_storage_for_limited-memory_quasi-Newton_algorithms),
you can get and set the number M of stored vectors for limited-memory
quasi-Newton algorithms, via integer-valued property
```julia
vector_storage(opt::Opt)
vector_storage!(opt::Opt, value)
```
The default is `0`, in which case NLopt uses a heuristic nonzero value as
determined by individual algorithms.

### Version number

The version number of NLopt is given by the global variable:
```julia
NLOPT_VERSION::VersionNumber
```
where `VersionNumber` is a built-in Julia type from the Julia standard library.

## Thread safety

The underlying NLopt library is threadsafe; however, re-using the same `Opt`
object across multiple threads is not.

As an example, instead of:
```julia
using NLopt
opt = Opt(:LD_MMA, 2)
# Define problem
solutions = Vector{Any}(undef, 10)
Threads.@threads for i in 1:10
    # Not thread-safe because `opt` is re-used
    solutions[i] = optimize(opt, rand(2))
end
```
Do instead:
```julia
solutions = Vector{Any}(undef, 10)
Threads.@threads for i in 1:10
    # Thread-safe because a new `opt` is created for each thread
    opt = Opt(:LD_MMA, 2)
    # Define problem
    solutions[i] = optimize(opt, rand(2))
end
```

## Author

This module was initially written by [Steven G. Johnson](http://math.mit.edu/~stevenj/),
with subsequent contributions by several other authors (see the git history).

# Copyright (c) 2013: Steven G. Johnson and contributors
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module NLopt

using CEnum: @cenum
using NLopt_jll: libnlopt

############################################################################

function version()
    major, minor, patch = Ref{Cint}(), Ref{Cint}(), Ref{Cint}()
    nlopt_version(major, minor, patch)
    return VersionNumber(major[], minor[], patch[])
end

include("libnlopt.jl")

############################################################################
# Mirrors of NLopt's C enum constants:

@static if v"2.9" ≤ version() < v"2.10"
    @enum Algorithm::Cint begin
        GN_DIRECT = 0
        GN_DIRECT_L
        GN_DIRECT_L_RAND
        GN_DIRECT_NOSCAL
        GN_DIRECT_L_NOSCAL
        GN_DIRECT_L_RAND_NOSCAL
        GN_ORIG_DIRECT
        GN_ORIG_DIRECT_L
        GD_STOGO
        GD_STOGO_RAND
        # LD_LBFGS_NOCEDAL: temporarily removed in nlopt 2.9 (nlopt#584)
        LD_LBFGS
        LN_PRAXIS
        LD_VAR1
        LD_VAR2
        LD_TNEWTON
        LD_TNEWTON_RESTART
        LD_TNEWTON_PRECOND
        LD_TNEWTON_PRECOND_RESTART
        GN_CRS2_LM
        GN_MLSL
        GD_MLSL
        GN_MLSL_LDS
        GD_MLSL_LDS
        LD_MMA
        LN_COBYLA
        LN_NEWUOA
        LN_NEWUOA_BOUND
        LN_NELDERMEAD
        LN_SBPLX
        LN_AUGLAG
        LD_AUGLAG
        LN_AUGLAG_EQ
        LD_AUGLAG_EQ
        LN_BOBYQA
        GN_ISRES
        AUGLAG
        AUGLAG_EQ
        G_MLSL
        G_MLSL_LDS
        LD_SLSQP
        LD_CCSAQ
        GN_ESCH
        GN_AGS
    end
else
    @enum Algorithm::Cint begin
        GN_DIRECT = 0
        GN_DIRECT_L
        GN_DIRECT_L_RAND
        GN_DIRECT_NOSCAL
        GN_DIRECT_L_NOSCAL
        GN_DIRECT_L_RAND_NOSCAL
        GN_ORIG_DIRECT
        GN_ORIG_DIRECT_L
        GD_STOGO
        GD_STOGO_RAND
        LD_LBFGS_NOCEDAL
        LD_LBFGS
        LN_PRAXIS
        LD_VAR1
        LD_VAR2
        LD_TNEWTON
        LD_TNEWTON_RESTART
        LD_TNEWTON_PRECOND
        LD_TNEWTON_PRECOND_RESTART
        GN_CRS2_LM
        GN_MLSL
        GD_MLSL
        GN_MLSL_LDS
        GD_MLSL_LDS
        LD_MMA
        LN_COBYLA
        LN_NEWUOA
        LN_NEWUOA_BOUND
        LN_NELDERMEAD
        LN_SBPLX
        LN_AUGLAG
        LD_AUGLAG
        LN_AUGLAG_EQ
        LD_AUGLAG_EQ
        LN_BOBYQA
        GN_ISRES
        AUGLAG
        AUGLAG_EQ
        G_MLSL
        G_MLSL_LDS
        LD_SLSQP
        LD_CCSAQ
        GN_ESCH
        GN_AGS
    end
end

Base.convert(::Type{nlopt_algorithm}, a::Algorithm) = nlopt_algorithm(Int(a))
Base.convert(::Type{Algorithm}, r::nlopt_algorithm) = Algorithm(Int(r))

function Algorithm(name::Symbol)::Algorithm
    algorithm = nlopt_algorithm_from_string("$name")
    if UInt32(algorithm) == 0xffffffff
        throw(ArgumentError("unknown algorithm: $name"))
    end
    return algorithm
end

# enum nlopt_result
@enum Result::Cint begin
    FORCED_STOP = -5
    ROUNDOFF_LIMITED = -4
    OUT_OF_MEMORY = -3
    INVALID_ARGS = -2
    FAILURE = -1
    SUCCESS = 1
    STOPVAL_REACHED = 2
    FTOL_REACHED = 3
    XTOL_REACHED = 4
    MAXEVAL_REACHED = 5
    MAXTIME_REACHED = 6
end

Base.convert(::Type{nlopt_result}, r::Result) = nlopt_result(Int(r))
Base.convert(::Type{Result}, r::nlopt_result) = Result(Int(r))

# so that result < 0 checks continue to work
Base.isless(x::Integer, r::Result) = isless(x, Cint(r))
Base.isless(r::Result, x::Integer) = isless(Cint(r), x)
# so that == :Foo checks continue to work
Base.:(==)(s::Symbol, r::Result) = s == Symbol(r)
Base.:(==)(r::Result, s::Symbol) = s == r

############################################################################
# wrapper around nlopt_opt type

macro const_field(expr)
    if VERSION >= v"1.8.0-"
        Expr(:const, esc(expr))
    else
        esc(expr)
    end
end

# pass both f and o to the callback so that we can handle exceptions
mutable struct Callback_Data{F,O}
    @const_field f::F
    @const_field o::O # Opt
end

function Base.unsafe_convert(::Type{Ptr{Cvoid}}, c::Callback_Data)
    return pointer_from_objref(c)
end

mutable struct Opt
    opt::Ptr{Cvoid}

    # need to store callback data for objective and constraints in
    # Opt so that they aren't garbage-collected.  cb[1] is the objective.
    @const_field cb::Vector{Callback_Data}

    exception::Any

    # These cached arrays should only be used in the callback
    # if their pointer value and size matches the ones passed into the callback
    x_cache::Vector{Cdouble}
    res_cache::Vector{Cdouble}
    grad_cache::Vector{Cdouble}
    grad2_cache::Matrix{Cdouble}

    function Opt(p::Ptr{Cvoid})
        @assert p != C_NULL
        opt = new(
            p,
            Array{Callback_Data}(undef, 1),
            nothing,
            _EMPTY_VECTOR,
            _EMPTY_VECTOR,
            _EMPTY_VECTOR,
            _EMPTY_MATRIX,
        )
        finalizer(destroy, opt)
        return opt
    end
end

function Opt(algorithm::Algorithm, n::Integer)
    if n < 0
        throw(ArgumentError("invalid dimension $n < 0"))
    end
    p = nlopt_create(algorithm, n)
    return Opt(p)
end

function Opt(algorithm::Union{Integer,Symbol}, n::Integer)
    return Opt(Algorithm(algorithm), n)
end

Base.unsafe_convert(::Type{Ptr{Cvoid}}, o::Opt) = getfield(o, :opt)

destroy(o::Opt) = nlopt_destroy(o)

Base.ndims(o::Opt)::Int = nlopt_get_dimension(o)

algorithm(o::Opt)::Algorithm = nlopt_get_algorithm(o)

Base.show(io::IO, o::Opt) = print(io, "Opt($(algorithm(o)), $(ndims(o)))")

############################################################################
# copying is a little tricky because we have to tell NLopt to use new
# Callback_Data.

function munge_callback(p::Ptr{Cvoid}, p_user_data::Ptr{Cvoid})
    old_to_new_pointer_map =
        unsafe_pointer_to_objref(p_user_data)::Dict{Ptr{Cvoid},Ptr{Cvoid}}
    return old_to_new_pointer_map[p]
end

function Base.copy(opt::Opt)
    p = nlopt_copy(opt)
    if p == C_NULL
        error("Error in nlopt_copy")
    end
    new_opt = Opt(p)
    opt_callbacks = getfield(opt, :cb)
    new_callbacks = getfield(new_opt, :cb)
    resize!(new_callbacks, length(opt_callbacks))
    old_to_new_pointer_map = Dict{Ptr{Cvoid},Ptr{Cvoid}}(C_NULL => C_NULL)
    for i in 1:length(opt_callbacks)
        if isassigned(opt_callbacks, i)
            new_callbacks[i] = Callback_Data(opt_callbacks[i].f, new_opt)
            old_to_new_pointer_map[pointer_from_objref(opt_callbacks[i])] =
                pointer_from_objref(new_callbacks[i])
        end
    end
    # nlopt_munge_data is a routine that allows us to convert all pointers to
    # existing Callback_Data objects into pointers for the corresponding object
    # in new_callbacks.
    c_fn = @cfunction(munge_callback, Ptr{Cvoid}, (Ptr{Cvoid}, Ptr{Cvoid}))
    GC.@preserve old_to_new_pointer_map begin
        p_old_to_new_pointer_map = pointer_from_objref(old_to_new_pointer_map)
        nlopt_munge_data(new_opt, c_fn, p_old_to_new_pointer_map)
    end
    return new_opt
end

############################################################################
# converting error results into exceptions

struct ForcedStop <: Exception end

function errmsg(o::Opt)
    msg = nlopt_get_errmsg(o)
    return msg == C_NULL ? nothing : unsafe_string(msg)
end

function _errmsg(o::Opt)
    s = errmsg(o)
    return s === nothing || isempty(s) ? "" : ": " * s
end

# check result and throw an exception if necessary
chk(o::Opt, result::nlopt_result) = chk(o, convert(Result, result))

function chk(o::Opt, result::Result)
    if result >= 0
        return
    elseif result == ROUNDOFF_LIMITED
        return
    elseif result == INVALID_ARGS
        throw(ArgumentError("invalid NLopt arguments" * _errmsg(o)))
    elseif result == OUT_OF_MEMORY
        throw(OutOfMemoryError())
    else
        error("nlopt failure $result", _errmsg(o))
    end
end

############################################################################
# getting and setting scalar and vector parameters

stopval(o::Opt) = nlopt_get_stopval(o)
stopval!(o::Opt, val::Real) = chk(o, nlopt_set_stopval(o, val))

ftol_rel(o::Opt) = nlopt_get_ftol_rel(o)
ftol_rel!(o::Opt, val::Real) = chk(o, nlopt_set_ftol_rel(o, val))

ftol_abs(o::Opt) = nlopt_get_ftol_abs(o)
ftol_abs!(o::Opt, val::Real) = chk(o, nlopt_set_ftol_abs(o, val))

xtol_rel(o::Opt) = nlopt_get_xtol_rel(o)
xtol_rel!(o::Opt, val::Real) = chk(o, nlopt_set_xtol_rel(o, val))

maxeval(o::Opt) = nlopt_get_maxeval(o)
maxeval!(o::Opt, val::Integer) = chk(o, nlopt_set_maxeval(o, val))

maxtime(o::Opt) = nlopt_get_maxtime(o)
maxtime!(o::Opt, val::Real) = chk(o, nlopt_set_maxtime(o, val))

force_stop(o::Opt) = nlopt_get_force_stop(o)
force_stop!(o::Opt, val::Integer) = chk(o, nlopt_set_force_stop(o, val))
force_stop!(o::Opt) = force_stop!(o, 1)

population(o::Opt) = nlopt_get_population(o)
population!(o::Opt, val::Integer) = chk(o, nlopt_set_population(o, val))

vector_storage(o::Opt) = nlopt_get_vector_storage(o)
vector_storage!(o::Opt, val::Integer) = chk(o, nlopt_set_vector_storage(o, val))

############################################################################
# Optimizer parameters

function lower_bounds(
    o::Opt,
    v::Vector{Cdouble} = Array{Cdouble}(undef, ndims(o)),
)
    if length(v) != ndims(o)
        throw(BoundsError())
    end
    chk(o, nlopt_get_lower_bounds(o, v))
    return v
end

function lower_bounds!(o::Opt, v::Vector{Cdouble})
    if length(v) != ndims(o)
        throw(BoundsError())
    end
    return chk(o, nlopt_set_lower_bounds(o, v))
end

function lower_bounds!(o::Opt, v::AbstractVector{<:Real})
    return lower_bounds!(o, Array{Cdouble}(v))
end

lower_bounds!(o::Opt, val::Real) = chk(o, nlopt_set_lower_bounds1(o, val))

function upper_bounds(
    o::Opt,
    v::Vector{Cdouble} = Array{Cdouble}(undef, ndims(o)),
)
    if length(v) != ndims(o)
        throw(BoundsError())
    end
    chk(o, nlopt_get_upper_bounds(o, v))
    return v
end

function upper_bounds!(o::Opt, v::Vector{Cdouble})
    if length(v) != ndims(o)
        throw(BoundsError())
    end
    return chk(o, nlopt_set_upper_bounds(o, v))
end

function upper_bounds!(o::Opt, v::AbstractVector{<:Real})
    return upper_bounds!(o, Array{Cdouble}(v))
end

upper_bounds!(o::Opt, val::Real) = chk(o, nlopt_set_upper_bounds1(o, val))

function xtol_abs(o::Opt, v::Vector{Cdouble} = Array{Cdouble}(undef, ndims(o)))
    if length(v) != ndims(o)
        throw(BoundsError())
    end
    chk(o, nlopt_get_xtol_abs(o, v))
    return v
end

function xtol_abs!(o::Opt, v::Vector{Cdouble})
    if length(v) != ndims(o)
        throw(BoundsError())
    end
    return chk(o, nlopt_set_xtol_abs(o, v))
end

function xtol_abs!(o::Opt, v::AbstractVector{<:Real})
    return xtol_abs!(o, Array{Cdouble}(v))
end

xtol_abs!(o::Opt, val::Real) = chk(o, nlopt_set_xtol_abs1(o, val))

function local_optimizer!(o::Opt, lo::Opt)
    return chk(o, nlopt_set_local_optimizer(o, lo))
end

function default_initial_step!(o::Opt, x::Vector{Cdouble})
    if length(x) != ndims(o)
        throw(BoundsError())
    end
    return chk(o, nlopt_set_default_initial_step(o, x))
end

function default_initial_step!(o::Opt, x::AbstractVector{<:Real})
    return default_initial_step!(o, Array{Cdouble}(x))
end

function initial_step!(o::Opt, dx::Vector{Cdouble})
    if length(dx) != ndims(o)
        throw(BoundsError())
    end
    return chk(o, nlopt_set_initial_step(o, dx))
end

function initial_step!(o::Opt, dx::AbstractVector{<:Real})
    return initial_step!(o, Array{Cdouble}(dx))
end

function initial_step!(o::Opt, dx::Real)
    return chk(o, nlopt_set_initial_step1(o, dx))
end

function initial_step(o::Opt, x::Vector{Cdouble}, dx::Vector{Cdouble})
    if length(x) != ndims(o) || length(dx) != ndims(o)
        throw(BoundsError())
    end
    chk(o, nlopt_get_initial_step(o, x, dx))
    return dx
end

function initial_step(o::Opt, x::AbstractVector{<:Real})
    return initial_step(o, Array{Cdouble}(x), Array{Cdouble}(undef, ndims(o)))
end

############################################################################

function algorithm_name(a::Algorithm)
    p = nlopt_algorithm_name(a)
    # pointer cannot be C_NULL because we are using only valid Enums
    @assert p !== C_NULL
    return unsafe_string(p)
end

algorithm_name(a::Union{Integer,Symbol}) = algorithm_name(Algorithm(a))

algorithm_name(o::Opt) = algorithm_name(algorithm(o))

function Base.show(io::IO, ::MIME"text/plain", a::Algorithm)
    show(io, a)
    return print(io, ": ", algorithm_name(a))
end

numevals(o::Opt) = nlopt_get_numevals(o)

############################################################################

const NLOPT_VERSION = version()

############################################################################

srand(seed::Integer) = nlopt_srand(seed)

srand_time() = nlopt_srand_time()

############################################################################
# Objective function:

const _EMPTY_VECTOR = Cdouble[]
const _EMPTY_MATRIX = zeros(Cdouble, 0, 0)

@inline function _get_empty_vector()
    if !isempty(_EMPTY_VECTOR)
        empty!(_EMPTY_VECTOR)  # Reset for future calls
        error(
            "The builtin _EMPTY_VECTOR was modified by the user. " *
            "If the gradient vector is empty, do not modify it in a callback.",
        )
    end
    return _EMPTY_VECTOR
end

@inline function _wrap_pointer(
    o::Opt,
    p::Ptr,
    sz::Tuple,
    field::Symbol,
    isgrad::Bool,
)
    cache = getfield(o, field)
    if p == pointer(cache) && size(cache) == sz
        return cache
    elseif isgrad && p == C_NULL
        return length(sz) == 1 ? _get_empty_vector() : _EMPTY_MATRIX
    else
        cache = unsafe_wrap(Array, p, sz)
        setfield!(o, field, cache)
        return cache
    end
end

function nlopt_callback_wrapper(
    n::Cuint,
    p_x::Ptr{Cdouble},
    p_grad::Ptr{Cdouble},
    d::Callback_Data,
)::Cdouble
    o = d.o
    x = _wrap_pointer(o, p_x, (n,), :x_cache, false)
    grad = _wrap_pointer(o, p_grad, (n,), :grad_cache, true)
    try
        return d.f(x, grad)
    catch e
        _catch_forced_stop(o, e)
    end
    return NaN
end

function min_objective!(o::Opt, f::F) where {F}
    cb = Callback_Data{F,Opt}(f, o)
    getfield(o, :cb)[1] = cb
    c_fn = @cfunction(
        nlopt_callback_wrapper,
        Cdouble,
        (Cuint, Ptr{Cdouble}, Ptr{Cdouble}, Ref{Callback_Data{F,Opt}})
    )
    return chk(o, nlopt_set_min_objective(o, c_fn, cb))
end

function max_objective!(o::Opt, f::F) where {F}
    cb = Callback_Data{F,Opt}(f, o)
    getfield(o, :cb)[1] = cb
    c_fn = @cfunction(
        nlopt_callback_wrapper,
        Cdouble,
        (Cuint, Ptr{Cdouble}, Ptr{Cdouble}, Ref{Callback_Data{F,Opt}})
    )
    return chk(o, nlopt_set_max_objective(o, c_fn, cb))
end

############################################################################
# Nonlinear constraints:

function inequality_constraint!(o::Opt, f::F, tol::Real = 0.0) where {F}
    cb = Callback_Data{F,Opt}(f, o)
    push!(getfield(o, :cb), cb)
    c_fn = @cfunction(
        nlopt_callback_wrapper,
        Cdouble,
        (Cuint, Ptr{Cdouble}, Ptr{Cdouble}, Ref{Callback_Data{F,Opt}})
    )
    return chk(o, nlopt_add_inequality_constraint(o, c_fn, cb, tol))
end

function equality_constraint!(o::Opt, f::F, tol::Real = 0.0) where {F}
    cb = Callback_Data{F,Opt}(f, o)
    push!(getfield(o, :cb), cb)
    c_fn = @cfunction(
        nlopt_callback_wrapper,
        Cdouble,
        (Cuint, Ptr{Cdouble}, Ptr{Cdouble}, Ref{Callback_Data{F,Opt}})
    )
    return chk(o, nlopt_add_equality_constraint(o, c_fn, cb, tol))
end

function remove_constraints!(o::Opt)
    resize!(getfield(o, :cb), 1)
    chk(o, nlopt_remove_inequality_constraints(o))
    chk(o, nlopt_remove_equality_constraints(o))
    return
end

############################################################################
# Vector-valued constraints

function nlopt_vcallback_wrapper(
    m::Cuint,
    p_res::Ptr{Cdouble},
    n::Cuint,
    p_x::Ptr{Cdouble},
    p_grad::Ptr{Cdouble},
    d::Callback_Data,
)
    o = d.o
    res = _wrap_pointer(o, p_res, (m,), :res_cache, false)
    x = _wrap_pointer(o, p_x, (n,), :x_cache, false)
    grad = _wrap_pointer(o, p_grad, (n, m), :grad2_cache, true)
    try
        d.f(res, x, grad)
    catch e
        _catch_forced_stop(o, e)
    end
    return
end

function _catch_forced_stop(o::Opt, e)
    if e isa ForcedStop
        setfield!(o, :exception, e)
    elseif e isa InterruptException
        setfield!(o, :exception, ForcedStop())
    else
        setfield!(o, :exception, CapturedException(e, catch_backtrace()))
    end
    force_stop!(o)
    return
end

function inequality_constraint!(o::Opt, f::F, tol::Vector{Cdouble}) where {F}
    cb = Callback_Data{F,Opt}(f, o)
    push!(getfield(o, :cb), cb)
    c_fn = @cfunction(
        nlopt_vcallback_wrapper,
        Cvoid,
        (
            Cuint,
            Ptr{Cdouble},
            Cuint,
            Ptr{Cdouble},
            Ptr{Cdouble},
            Ref{Callback_Data{F,Opt}},
        ),
    )
    ret = nlopt_add_inequality_mconstraint(o, length(tol), c_fn, cb, tol)
    return chk(o, ret)
end

function inequality_constraint!(o::Opt, f, tol::AbstractVector{<:Real})
    return inequality_constraint!(o, f, Array{Float64}(tol))
end

function inequality_constraint!(o::Opt, m::Integer, f, tol::Real = 0.0)
    return inequality_constraint!(o, f, fill(Cdouble(tol), m))
end

function equality_constraint!(o::Opt, f::F, tol::Vector{Cdouble}) where {F}
    cb = Callback_Data{F,Opt}(f, o)
    push!(getfield(o, :cb), cb)
    c_fn = @cfunction(
        nlopt_vcallback_wrapper,
        Cvoid,
        (
            Cuint,
            Ptr{Cdouble},
            Cuint,
            Ptr{Cdouble},
            Ptr{Cdouble},
            Ref{Callback_Data{F,Opt}},
        ),
    )
    return chk(o, nlopt_add_equality_mconstraint(o, length(tol), c_fn, cb, tol))
end

function equality_constraint!(o::Opt, f, tol::AbstractVector{<:Real})
    return equality_constraint!(o, f, Array{Float64}(tol))
end

function equality_constraint!(o::Opt, m::Integer, f, tol::Real = 0.0)
    return equality_constraint!(o, f, fill(Cdouble(tol), m))
end

############################################################################
# Dict-like API for generic algorithm properties

"""
    OptParams <: AbstractDict{String, Float64}

Dictionary-like structure for accessing algorithm-specific parameters for
an NLopt optimization object `opt`, returned by `opt.params`.

Use this object to both set and view these string-keyed numeric parameters.
"""
struct OptParams <: AbstractDict{String,Float64}
    o::Opt
end

Base.length(p::OptParams)::Int = nlopt_num_params(p.o)

Base.haskey(p::OptParams, s::AbstractString)::Bool = nlopt_has_param(p.o, s)

function Base.get(p::OptParams, s::AbstractString, default::Float64)
    return nlopt_get_param(p.o, s, default)
end

function Base.get(p::OptParams, s::AbstractString, default)
    if !haskey(p, s)
        return default
    end
    return nlopt_get_param(p.o, s, NaN)
end

function Base.setindex!(p::OptParams, v::Real, s::AbstractString)
    ret = nlopt_set_param(p.o, s, v)
    return chk(p.o, ret)
end

function Base.setindex!(p::OptParams, v::Algorithm, s::AbstractString)
    return setindex!(p, Int(v), s)
end

function Base.iterate(p::OptParams, state = 0)
    if state >= length(p)
        return nothing
    end
    name_ptr = nlopt_nth_param(p.o, state)
    @assert name_ptr != C_NULL
    name = unsafe_string(name_ptr)
    return name => p[name], state + 1
end

############################################################################
# property-based getters setters opt.foo for Julia 0.7
# … at some point we will deprecate the old interface.

function Base.getproperty(o::Opt, p::Symbol)
    if p === :lower_bounds
        return lower_bounds(o)
    elseif p === :upper_bounds
        return upper_bounds(o)
    elseif p === :stopval
        return stopval(o)
    elseif p === :ftol_rel
        return ftol_rel(o)
    elseif p === :ftol_abs
        return ftol_abs(o)
    elseif p === :xtol_rel
        return xtol_rel(o)
    elseif p === :xtol_abs
        return xtol_abs(o)
    elseif p === :maxeval
        return maxeval(o)
    elseif p === :maxtime
        return maxtime(o)
    elseif p === :force_stop
        return force_stop(o)
    elseif p === :population
        return population(o)
    elseif p === :vector_storage
        return vector_storage(o)
    elseif p === :initial_step
        error(
            "Getting `initial_step` is unsupported. Use " *
            "`initial_step(opt, x)` to access the initial step at a point `x`.",
        )
    elseif p === :algorithm
        return algorithm(o)
    elseif p === :numevals
        return numevals(o)
    elseif p === :errmsg
        return errmsg(o)
    elseif p === :params
        return OptParams(o)
    else
        error("type Opt has no readable property $p")
    end
end

function Base.setproperty!(o::Opt, p::Symbol, x)
    if p === :lower_bounds
        lower_bounds!(o, x)
    elseif p === :upper_bounds
        upper_bounds!(o, x)
    elseif p === :stopval
        stopval!(o, x)
    elseif p === :ftol_rel
        ftol_rel!(o, x)
    elseif p === :ftol_abs
        ftol_abs!(o, x)
    elseif p === :xtol_rel
        xtol_rel!(o, x)
    elseif p === :xtol_abs
        xtol_abs!(o, x)
    elseif p === :maxeval
        maxeval!(o, x)
    elseif p === :maxtime
        maxtime!(o, x)
    elseif p === :force_stop
        force_stop!(o, x)
    elseif p === :population
        population!(o, x)
    elseif p === :vector_storage
        vector_storage!(o, x)
    elseif p === :local_optimizer
        local_optimizer!(o, x)
    elseif p === :default_initial_step
        default_initial_step!(o, x)
    elseif p === :initial_step
        initial_step!(o, x)
    elseif p === :min_objective
        min_objective!(o, x)
    elseif p === :max_objective
        max_objective!(o, x)
    elseif p === :inequality_constraint
        inequality_constraint!(o, x)
    elseif p === :equality_constraint
        equality_constraint!(o, x)
    else
        error("type Opt has no writable property $p")
    end
    return x
end

function Base.propertynames(o::Opt)
    return (
        :lower_bounds,
        :upper_bounds,
        :stopval,
        :ftol_rel,
        :ftol_abs,
        :xtol_rel,
        :xtol_abs,
        :maxeval,
        :maxtime,
        :force_stop,
        :population,
        :vector_storage,
        :initial_step,
        :algorithm,
        :local_optimizer,
        :default_initial_step,
        :initial_step,
        :min_objective,
        :max_objective,
        :inequality_constraint,
        :equality_constraint,
        :numevals,
        :errmsg,
        :params,
    )
end

############################################################################
# Perform the optimization:

function optimize!(o::Opt, x::Vector{Cdouble})
    if length(x) != ndims(o)
        throw(BoundsError())
    end
    opt_f = Ref{Cdouble}(NaN)
    ret::Result = nlopt_optimize(o, x, opt_f)
    # We do not need to check the value of `ret`, except if it is a FORCED_STOP
    # with a Julia-related exception from a callback
    if ret == FORCED_STOP
        exception = getfield(o, :exception)
        setfield!(o, :exception, nothing)
        if exception !== nothing && !(exception isa ForcedStop)
            throw(exception)
        end
    end
    return opt_f[], x, Symbol(ret)
end

function optimize(o::Opt, x::AbstractVector{<:Real})
    return optimize!(o, copyto!(Array{Cdouble}(undef, length(x)), x))
end

export Opt,
    NLOPT_VERSION,
    algorithm,
    algorithm_name,
    ForcedStop,
    lower_bounds!,
    lower_bounds,
    upper_bounds!,
    upper_bounds,
    stopval!,
    stopval,
    ftol_rel!,
    ftol_rel,
    ftol_abs!,
    ftol_abs,
    xtol_rel!,
    xtol_rel,
    xtol_abs!,
    xtol_abs,
    maxeval!,
    maxeval,
    maxtime!,
    maxtime,
    force_stop!,
    force_stop,
    population!,
    population,
    vector_storage!,
    vector_storage,
    initial_step!,
    initial_step,
    default_initial_step!,
    local_optimizer!,
    min_objective!,
    max_objective!,
    equality_constraint!,
    inequality_constraint!,
    remove_constraints!,
    optimize!,
    optimize,
    Algorithm,
    Result

@static if !isdefined(Base, :get_extension)
    include("../ext/NLoptMathOptInterfaceExt.jl")
    using .NLoptMathOptInterfaceExt
    const Optimizer = NLoptMathOptInterfaceExt.Optimizer
else
    # declare this upfront so that the MathOptInterface extension can assign it
    # without creating a new global
    @eval global Optimizer
end

end # module

# Copyright (c) 2013: Steven G. Johnson and contributors
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestCAPI

using NLopt
using Test

function runtests()
    for name in names(@__MODULE__; all = true)
        if !startswith("$(name)", "test_")
            continue
        end
        @testset "$(name)" begin
            getfield(@__MODULE__, name)()
        end
    end
    return
end

function test_readme_example()
    function my_objective_fn(x::Vector, grad::Vector)
        if length(grad) > 0
            grad[1] = 0
            grad[2] = 0.5 / sqrt(x[2])
        end
        return sqrt(x[2])
    end
    function my_constraint_fn(x::Vector, grad::Vector, a, b)
        if length(grad) > 0
            grad[1] = 3 * a * (a * x[1] + b)^2
            grad[2] = -1
        end
        return (a * x[1] + b)^3 - x[2]
    end
    opt = Opt(:LD_MMA, 2)
    lower_bounds!(opt, [-Inf, 0.0])
    xtol_rel!(opt, 1e-4)
    min_objective!(opt, my_objective_fn)
    inequality_constraint!(opt, (x, g) -> my_constraint_fn(x, g, 2, 0), 1e-8)
    inequality_constraint!(opt, (x, g) -> my_constraint_fn(x, g, -1, 1), 1e-8)
    min_f, min_x, ret = optimize(opt, [1.234, 5.678])
    @test min_f ≈ 0.5443310477213124
    @test min_x ≈ [0.3333333342139688, 0.29629628951338166]
    @test ret == :XTOL_REACHED
    return
end

function test_readme_example_vector()
    function my_objective_fn(x::Vector, grad::Vector)
        if length(grad) > 0
            grad[1] = 0
            grad[2] = 0.5 / sqrt(x[2])
        end
        return sqrt(x[2])
    end
    function my_constraint_fn(ret, x::Vector, grad::Matrix)
        if length(grad) > 0
            grad[1, 1] = 3 * 2 * (2 * x[1] + 0)^2
            grad[2, 1] = -1
            grad[1, 2] = 3 * -1 * (-1 * x[1] + 1)^2
            grad[2, 2] = -1
        end
        ret[1] = (2 * x[1] + 0)^3 - x[2]
        ret[2] = (-1 * x[1] + 1)^3 - x[2]
        return
    end
    opt = Opt(:LD_MMA, 2)
    lower_bounds!(opt, [-Inf, 0.0])
    xtol_rel!(opt, 1e-4)
    min_objective!(opt, my_objective_fn)
    inequality_constraint!(opt, my_constraint_fn, [1e-8, 1e-8])
    min_f, min_x, ret = optimize(opt, [1.234, 5.678])
    @test min_f ≈ 0.5443310477213124
    @test min_x ≈ [0.3333333342139688, 0.29629628951338166]
    @test ret == :XTOL_REACHED
    return
end

function test_readme_example_vector_real_tol()
    function my_objective_fn(x::Vector, grad::Vector)
        if length(grad) > 0
            grad[1] = 0
            grad[2] = 0.5 / sqrt(x[2])
        end
        return sqrt(x[2])
    end
    function my_constraint_fn(ret, x::Vector, grad::Matrix)
        if length(grad) > 0
            grad[1, 1] = 3 * 2 * (2 * x[1] + 0)^2
            grad[2, 1] = -1
            grad[1, 2] = 3 * -1 * (-1 * x[1] + 1)^2
            grad[2, 2] = -1
        end
        ret[1] = (2 * x[1] + 0)^3 - x[2]
        ret[2] = (-1 * x[1] + 1)^3 - x[2]
        return
    end
    opt = Opt(:LD_MMA, 2)
    lower_bounds!(opt, [-Inf, 0.0])
    xtol_rel!(opt, 1e-4)
    min_objective!(opt, my_objective_fn)
    tol = [1 // 1_000_000, 1 // 1_000_000]
    inequality_constraint!(opt, my_constraint_fn, tol)
    min_f, min_x, ret = optimize(opt, [1.234, 5.678])
    @test min_f ≈ 0.5443310477213124
    @test min_x ≈ [0.3333333342139688, 0.29629628951338166]
    @test ret == :XTOL_REACHED
    return
end

function test_vector_equality_constraint_real_tol()
    function my_objective_fn(x::Vector, grad::Vector)
        if length(grad) > 0
            grad[1] = 0
            grad[2] = 0.5 / sqrt(x[2])
        end
        return sqrt(x[2])
    end
    function my_constraint_fn(ret, x::Vector, grad::Matrix)
        if length(grad) > 0
            grad[1, 1] = 3 * 2 * (2 * x[1] + 0)^2
            grad[2, 1] = -1
            grad[1, 2] = 3 * -1 * (-1 * x[1] + 1)^2
            grad[2, 2] = -1
        end
        ret[1] = (2 * x[1] + 0)^3 - x[2]
        ret[2] = (-1 * x[1] + 1)^3 - x[2]
        return
    end
    opt = Opt(:LD_SLSQP, 2)
    lower_bounds!(opt, [-Inf, 0.0])
    xtol_rel!(opt, 1e-4)
    min_objective!(opt, my_objective_fn)
    tol = [1 // 1_000_000, 1 // 1_000_000]
    equality_constraint!(opt, my_constraint_fn, tol)
    min_f, min_x, ret = optimize(opt, [1.234, 5.678])
    @test min_f ≈ 0.5443310477213124
    @test min_x ≈ [0.3333333342139688, 0.29629628951338166]
    @test ret == :XTOL_REACHED
    return
end

function test_vector_equality_constraint_scalar_tol()
    function my_objective_fn(x::Vector, grad::Vector)
        if length(grad) > 0
            grad[1] = 0
            grad[2] = 0.5 / sqrt(x[2])
        end
        return sqrt(x[2])
    end
    function my_constraint_fn(ret, x::Vector, grad::Matrix)
        if length(grad) > 0
            grad[1, 1] = 3 * 2 * (2 * x[1] + 0)^2
            grad[2, 1] = -1
            grad[1, 2] = 3 * -1 * (-1 * x[1] + 1)^2
            grad[2, 2] = -1
        end
        ret[1] = (2 * x[1] + 0)^3 - x[2]
        ret[2] = (-1 * x[1] + 1)^3 - x[2]
        return
    end
    opt = Opt(:LD_SLSQP, 2)
    lower_bounds!(opt, [-Inf, 0.0])
    xtol_rel!(opt, 1e-4)
    min_objective!(opt, my_objective_fn)
    equality_constraint!(opt, 2, my_constraint_fn, 1 // 1_000_000)
    min_f, min_x, ret = optimize(opt, [1.234, 5.678])
    @test min_f ≈ 0.5443310477213124
    @test min_x ≈ [0.3333333342139688, 0.29629628951338166]
    @test ret == :XTOL_REACHED
    return
end

function test_vector_forced_stop()
    function my_objective_fn(x::Vector, grad::Vector)
        if length(grad) > 0
            grad[1] = 0
            grad[2] = 0.5 / sqrt(x[2])
        end
        return sqrt(x[2])
    end
    function my_constraint_fn(ret, x::Vector, grad::Matrix)
        throw(NLopt.ForcedStop())
        return
    end
    opt = Opt(:LD_MMA, 2)
    lower_bounds!(opt, [-Inf, 0.0])
    xtol_rel!(opt, 1e-4)
    min_objective!(opt, my_objective_fn)
    inequality_constraint!(opt, my_constraint_fn, [1e-8, 1e-8])
    min_f, min_x, ret = optimize(opt, [1.234, 5.678])
    @test ret == :FORCED_STOP
    return
end

function test_vector_interrupt_exception()
    function my_objective_fn(x::Vector, grad::Vector)
        if length(grad) > 0
            grad[1] = 0
            grad[2] = 0.5 / sqrt(x[2])
        end
        return sqrt(x[2])
    end
    function my_constraint_fn(ret, x::Vector, grad::Matrix)
        throw(NLopt.InterruptException())
        return
    end
    opt = Opt(:LD_MMA, 2)
    lower_bounds!(opt, [-Inf, 0.0])
    xtol_rel!(opt, 1e-4)
    min_objective!(opt, my_objective_fn)
    inequality_constraint!(opt, my_constraint_fn, [1e-8, 1e-8])
    min_f, min_x, ret = optimize(opt, [1.234, 5.678])
    @test ret == :FORCED_STOP
    return
end

function test_max_objective()
    opt = Opt(:LD_MMA, 2)
    function objective_fn(x, grad)
        if length(grad) > 0
            grad[1] = -2 * (x[1] - 0.5)
            grad[2] = -2 * (x[2] - 1)
        end
        return -((x[1] - 0.5)^2 + (x[2] - 1)^2)
    end
    xtol_abs!(opt, 1e-5)
    lower_bounds!(opt, -1)
    upper_bounds!(opt, 2)
    opt.max_objective = objective_fn
    minf, minx, ret = optimize(opt, [0.0, 0.0])
    @test ≈(minx, [0.5, 1.0]; atol = 1e-4)
    max_objective!(opt, objective_fn)
    minf, minx, ret = optimize(opt, [0.0, 0.0])
    @test ≈(minx, [0.5, 1.0]; atol = 1e-4)
    return
end

function test_min_objective()
    opt = Opt(:LD_MMA, 2)
    function objective_fn(x, grad)
        if length(grad) > 0
            grad[1] = 2 * (x[1] - 0.5)
            grad[2] = 2 * (x[2] - 1)
        end
        return (x[1] - 0.5)^2 + (x[2] - 1)^2
    end
    xtol_abs!(opt, 1e-5)
    lower_bounds!(opt, -1)
    upper_bounds!(opt, 2)
    opt.min_objective = objective_fn
    minf, minx, ret = optimize(opt, [0.0, 0.0])
    @test ≈(minx, [0.5, 1.0]; atol = 1e-4)
    min_objective!(opt, objective_fn)
    minf, minx, ret = optimize(opt, [0.0, 0.0])
    @test ≈(minx, [0.5, 1.0]; atol = 1e-4)
    return
end

function test_issue_163()
    opt = Opt(:LN_COBYLA, 2)
    opt.min_objective = (x, g) -> sum(x .^ 2)
    inequality_constraint!(opt, 2, (result, x, g) -> (result .= 1 .- x))
    (minf, minx, ret) = optimize(opt, [2.0, 2.0])
    @test minx ≈ [1.0, 1.0]
    return
end

function test_issue_132()
    opt = Opt(:LN_COBYLA, 2)
    err = ErrorException(
        "Getting `initial_step` is unsupported. Use " *
        "`initial_step(opt, x)` to access the initial step at a point `x`.",
    )
    @test_throws err opt.initial_step
    return
end

function test_issue_156_CapturedException()
    f(x, g = []) = (error("test error"); x[1]^2)
    opt = Opt(:LN_SBPLX, 1)
    opt.min_objective = f
    @test_throws CapturedException optimize(opt, [0.1234])
    @test getfield(opt, :exception) === nothing
    try
        optimize(opt, [0.1234])
    catch e
        # Check that the backtrace is being printed
        @test length(sprint(show, e)) > 100
    end
    return
end

function test_issue_156_ForcedStop()
    f(x, g = []) = (throw(NLopt.ForcedStop()); x[1]^2)
    opt = Opt(:LN_SBPLX, 1)
    opt.min_objective = f
    fmin, xmin, ret = optimize(opt, [0.1234])
    @test ret == :FORCED_STOP
    @test getfield(opt, :exception) === nothing
    return
end

function test_issue_156_no_error()
    f(x, g = []) = (x[1]^2)
    opt = Opt(:LN_SBPLX, 1)
    opt.min_objective = f
    fmin, xmin, ret = optimize(opt, [0.1234])
    @test ret ∈ (:SUCCESS, :FTOL_REACHED, :XTOL_REACHED)
    @test getfield(opt, :exception) === nothing
    return
end

function test_invalid_algorithms()
    @test_throws ArgumentError("unknown algorithm: BILL") Algorithm(:BILL)
    @test_throws ArgumentError("unknown algorithm: BILL") Opt(:BILL, 420)
    return
end

function test_issue_133()
    function rosenbrock(x::Vector, grad::Vector)
        if length(grad) > 0
            grad[1] = -400 * x[1] * (x[2] - x[1]^2) - 2 * (1 - x[1])
            grad[2] = 200 * (x[2] - x[1]^2)
        end
        return (1 - x[1])^2 + 100 * (x[2] - x[1]^2)^2
    end
    function ineq01(x::Vector, grad::Vector)
        if length(grad) > 0
            grad[1] = 1
            grad[2] = 2
        end
        return x[1] + 2 * x[2] - 1
    end
    function ineq02(x::Vector, grad::Vector)
        if length(grad) > 0
            grad[1] = 2 * x[1]
            grad[2] = 1
        end
        return x[1]^2 + x[2] - 1
    end
    function ineq03(x::Vector, grad::Vector)
        if length(grad) > 0
            grad[1] = 2 * x[1]
            grad[2] = -1
        end
        return x[1]^2 - x[2] - 1
    end
    function eq01(x::Vector, grad::Vector)
        if length(grad) > 0
            grad[1] = 2
            grad[2] = 1
        end
        return 2 * x[1] + x[2] - 1
    end
    opt = Opt(:LD_SLSQP, 2)
    opt.lower_bounds = [0, -0.5]
    opt.upper_bounds = [1, 2]
    opt.xtol_rel = 1e-21
    opt.min_objective = rosenbrock
    opt.inequality_constraint = ineq01
    opt.inequality_constraint = ineq02
    opt.inequality_constraint = ineq03
    opt.equality_constraint = eq01
    (minf, minx, ret) = optimize(opt, [0.5, 0])
    println("got $minf at $minx with constraints (returned $ret)")
    @test minx[1] ≈ 0.4149 rtol = 1e-3
    @test minx[2] ≈ 0.1701 rtol = 1e-3
    remove_constraints!(opt)
    (minf, minx, ret) = optimize(opt, [0.5, 0])
    println("got $minf at $minx after removing constraints (returned $ret)")
    @test minx[1] ≈ 1 rtol = 1e-5
    @test minx[2] ≈ 1 rtol = 1e-5
    return
end

function test_tutorial()
    count = 0 # keep track of # function evaluations
    function myfunc(x::Vector, grad::Vector)
        if length(grad) > 0
            grad[1] = 0
            grad[2] = 0.5 / sqrt(x[2])
        end
        count::Int += 1
        println("f_$count($x)")
        return sqrt(x[2])
    end
    function myconstraint(x::Vector, grad::Vector, a, b)
        if length(grad) > 0
            grad[1] = 3a * (a * x[1] + b)^2
            grad[2] = -1
        end
        return (a * x[1] + b)^3 - x[2]
    end
    opt = Opt(:LD_MMA, 2)
    opt.lower_bounds = [-Inf, 0.0]
    opt.xtol_rel = 1e-4
    opt.min_objective = myfunc
    opt.inequality_constraint = (x, g) -> myconstraint(x, g, 2, 0)
    opt.inequality_constraint = (x, g) -> myconstraint(x, g, -1, 1)
    # test algorithm-parameter API
    opt.params["verbosity"] = 0
    opt.params["inner_maxeval"] = 10
    opt.params["dual_alg"] = NLopt.LD_MMA
    @test opt.params == Dict(
        "verbosity" => 0,
        "inner_maxeval" => 10,
        "dual_alg" => Int(NLopt.LD_MMA),
    )
    @test get(opt.params, "foobar", 3.14159) === 3.14159
    (minf, minx, ret) = optimize(opt, [1.234, 5.678])
    println("got $minf at $minx after $count iterations (returned $ret)")
    @test minx[1] ≈ 1 / 3 rtol = 1e-5
    @test minx[2] ≈ 8 / 27 rtol = 1e-5
    @test minf ≈ sqrt(8 / 27) rtol = 1e-5
    @test ret == :XTOL_REACHED
    @test opt.numevals == count
    return
end

# It's not obvious why this test returns FAILURE. If it breaks in future, look
# for something else.
function test_return_FAILURE_from_optimize()
    function objective_fn(x, grad)
        if length(grad) > 0
            grad[1] = -2 * (1 - x[1]) - 400 * x[1] * (x[2] - x[1]^2)
            grad[2] = 200 * (x[2] - x[1]^2)
        end
        return (1 - x[1])^2 + 100 * (x[2] - x[1]^2)^2
    end
    function eq_constraint_fn(h, x, J)
        if length(J) > 0
            J[1, 1] = 2x[1]
            J[2, 1] = 2x[2]
        end
        h[1] = x[1]^2 + x[2]^2 - 1.0
        return
    end
    opt = Opt(:AUGLAG, 2)
    opt.local_optimizer = Opt(:LD_LBFGS, 2)
    opt.min_objective = objective_fn
    equality_constraint!(opt, eq_constraint_fn, [1e-8])
    _, _, ret = optimize(opt, [0.5, 0.5])
    @test ret == :FAILURE
    return
end

function test_optimize!_bounds_error()
    opt = Opt(:AUGLAG, 2)
    @test_throws BoundsError optimize!(opt, Cdouble[])
    return
end

function test_property_names()
    opt = Opt(:AUGLAG, 2)
    for (key, value) in (
        :lower_bounds => [1, 2],
        :upper_bounds => [2, 3],
        :stopval => 0.5,
        :ftol_rel => 0.1,
        :ftol_abs => 0.2,
        :xtol_rel => 0.3,
        :xtol_abs => [0.4, 0.5],  # TODO
        :maxeval => 5,
        :maxtime => 60.0,
        :force_stop => 1,
        :population => 0x00000001,
        :vector_storage => 0x00000002,
    )
        @test key in propertynames(opt)
        f = getfield(NLopt, key)
        @test getproperty(opt, key) == f(opt)
        setproperty!(opt, key, value)
        @test f(opt) == value
    end
    # Other getters
    @test :initial_step in propertynames(opt)
    @test_throws(
        ErrorException(
            "Getting `initial_step` is unsupported. Use `initial_step(opt, x)` to access the initial step at a point `x`.",
        ),
        opt.initial_step,
    )
    @test :algorithm in propertynames(opt)
    @test opt.algorithm == algorithm(opt)
    @test :numevals in propertynames(opt)
    @test opt.numevals == NLopt.numevals(opt)
    @test :errmsg in propertynames(opt)
    @test opt.errmsg == NLopt.errmsg(opt)
    @test :params in propertynames(opt)
    @test opt.params == NLopt.OptParams(opt)
    @test_throws ErrorException("type Opt has no readable property foo") opt.foo
    @test_throws(
        ErrorException("type Opt has no writable property foo"),
        setproperty!(opt, :foo, 1),
    )
    return
end

function test_get_opt_params_default()
    opt = Opt(:AUGLAG, 2)
    @test get(opt.params, "abc", :default) == :default
    return
end

function test_srand()
    @test NLopt.srand(1234) === nothing
    @test NLopt.srand_time() === nothing
    return
end

function test_algorithm()
    opt = Opt(:LD_LBFGS, 2)
    @test algorithm(opt) == NLopt.LD_LBFGS
    return
end

function test_algorithm_enum()
    @test convert(Algorithm, NLopt.NLOPT_LD_LBFGS) == NLopt.LD_LBFGS
    @test convert(NLopt.nlopt_algorithm, NLopt.LD_LBFGS) == NLopt.NLOPT_LD_LBFGS
    return
end

function test_result_enum()
    @test convert(Result, NLopt.NLOPT_SUCCESS) == NLopt.SUCCESS
    @test convert(NLopt.nlopt_result, NLopt.SUCCESS) == NLopt.NLOPT_SUCCESS
    return
end

function test_result_arithmetic()
    @test !(NLopt.SUCCESS < 0)
    @test 0 < NLopt.SUCCESS
    @test NLopt.SUCCESS == :SUCCESS
    @test :SUCCESS == NLopt.SUCCESS
    return
end

function test_opt_argument_error()
    @test_throws ArgumentError Opt(:LD_LBFGS, -2)
    return
end

function test_show_opt()
    opt = Opt(:LD_LBFGS, 2)
    @test sprint(show, opt) == "Opt(LD_LBFGS, 2)"
    return
end

function test_chk()
    opt = Opt(:LD_LBFGS, 2)
    @test NLopt.chk(opt, NLopt.SUCCESS) === nothing
    @test NLopt.chk(opt, NLopt.ROUNDOFF_LIMITED) === nothing
    @test_throws ArgumentError NLopt.chk(opt, NLopt.INVALID_ARGS)
    @test_throws OutOfMemoryError NLopt.chk(opt, NLopt.OUT_OF_MEMORY)
    @test_throws(
        ErrorException("nlopt failure FAILURE"),
        NLopt.chk(opt, NLopt.FAILURE)
    )
    return
end

function test_algorithm_name()
    algorithm = NLopt.LD_LBFGS
    sol = "Limited-memory BFGS (L-BFGS) (local, derivative-based)"
    @test algorithm_name(algorithm) == sol
    @test algorithm_name(:LD_LBFGS) == sol
    if v"2.9" ≤ NLopt.version() < v"2.10"
        @test algorithm_name(10) == sol
    else
        @test algorithm_name(11) == sol
    end
    opt = Opt(:LD_LBFGS, 2)
    @test algorithm_name(opt) == sol
    sprint(show, algorithm_name(:LD_LBFGS))
    @test sprint(show, MIME("text/plain"), NLopt.LD_LBFGS) ==
          "NLopt.LD_LBFGS: Limited-memory BFGS (L-BFGS) (local, derivative-based)"
    return
end

function test_lower_bounds()
    opt = Opt(:LD_LBFGS, 2)
    @test_throws BoundsError lower_bounds(opt, Cdouble[])
    @test_throws BoundsError lower_bounds!(opt, Cdouble[])
    v = [1.0, 2.0]
    @test lower_bounds(opt, v) === v
    @test v == [-Inf, -Inf]
    lower_bounds!(opt, 3)
    @test lower_bounds(opt) == [3.0, 3.0]
    lower_bounds!(opt, [1 // 2, 3 // 4])
    @test lower_bounds(opt) == [0.5, 0.75]
    return
end

function test_upper_bounds()
    opt = Opt(:LD_LBFGS, 2)
    @test_throws BoundsError upper_bounds(opt, Cdouble[])
    @test_throws BoundsError upper_bounds!(opt, Cdouble[])
    v = [1.0, 2.0]
    @test upper_bounds(opt, v) === v
    @test v == [Inf, Inf]
    upper_bounds!(opt, 3)
    @test upper_bounds(opt) == [3.0, 3.0]
    upper_bounds!(opt, [1 // 2, 3 // 4])
    @test upper_bounds(opt) == [0.5, 0.75]
    return
end

function test_xtol_abs()
    opt = Opt(:LD_LBFGS, 2)
    @test_throws BoundsError xtol_abs(opt, Cdouble[])
    @test_throws BoundsError xtol_abs!(opt, Cdouble[])
    v = [1.0, 2.0]
    @test xtol_abs(opt, v) === v
    @test v == [0.0, 0.0]
    xtol_abs!(opt, 3)
    @test xtol_abs(opt) == [3.0, 3.0]
    xtol_abs!(opt, [1 // 2, 3 // 4])
    @test xtol_abs(opt) == [0.5, 0.75]
    return
end

function test_initial_step()
    opt = Opt(:LD_LBFGS, 2)
    @test_throws BoundsError default_initial_step!(opt, Cdouble[])
    @test_throws BoundsError initial_step!(opt, Cdouble[])
    x = [1.0, 2.0]
    dx = [NaN, NaN]
    default_initial_step!(opt, [0.2, 0.4])
    @test initial_step(opt, x, dx) == [0.2, 0.4]
    opt.default_initial_step = [0.25, 0.45]
    @test initial_step(opt, x, dx) == [0.25, 0.45]
    default_initial_step!(opt, [1 // 2, 3 // 4])
    @test initial_step(opt, x, dx) == [0.5, 0.75]
    @test_throws BoundsError initial_step(opt, x, Cdouble[])
    @test_throws BoundsError initial_step(opt, Cdouble[], dx)
    default_initial_step!(opt, x)
    @test initial_step(opt, x, dx) == [1.0, 2.0]
    @test dx == [1.0, 2.0]
    @test initial_step(opt, [1 // 1, 2 // 1]) == [1.0, 2.0]
    initial_step!(opt, [0.1, 0.2])
    @test initial_step(opt, x, dx) == [0.1, 0.2]
    opt.initial_step = [0.15, 0.25]
    @test initial_step(opt, x, dx) == [0.15, 0.25]
    initial_step!(opt, [2 // 10, 3 // 10])
    @test initial_step(opt, x, dx) == [0.2, 0.3]
    initial_step!(opt, 1 // 2)
    @test initial_step(opt, x, dx) == [0.5, 0.5]
    return
end

function test_copy()
    function my_objective_fn(x::Vector, grad::Vector)
        if length(grad) > 0
            grad[1] = 0
            grad[2] = 0.5 / sqrt(x[2])
        end
        return sqrt(x[2])
    end
    function my_constraint_fn(x::Vector, grad::Vector, a, b)
        if length(grad) > 0
            grad[1] = 3 * a * (a * x[1] + b)^2
            grad[2] = -1
        end
        return (a * x[1] + b)^3 - x[2]
    end
    opt = Opt(:LD_MMA, 2)
    lower_bounds!(opt, [-Inf, 0.0])
    xtol_rel!(opt, 1e-4)
    min_objective!(opt, my_objective_fn)
    inequality_constraint!(opt, (x, g) -> my_constraint_fn(x, g, 2, 0), 1e-8)
    inequality_constraint!(opt, (x, g) -> my_constraint_fn(x, g, -1, 1), 1e-8)
    opt_2 = copy(opt)
    min_f, min_x, ret = optimize(opt_2, [1.234, 5.678])
    @test min_f ≈ 0.5443310477213124
    @test min_x ≈ [0.3333333342139688, 0.29629628951338166]
    @test ret == :XTOL_REACHED
    return
end

function test_copy_failure()
    opt = Opt(:LD_MMA, 2)
    setfield!(opt, :opt, C_NULL)
    @test_throws ErrorException("Error in nlopt_copy") copy(opt)
    return
end

function test_modify_empty_vector()
    function my_objective_fn(x::Vector, grad::Vector)
        if isempty(grad)
            resize!(grad, 1)
        end
        return (x[1] - 1.0)^2
    end
    opt = Opt(:LN_COBYLA, 1)
    xtol_rel!(opt, 1e-4)
    min_objective!(opt, my_objective_fn)
    @test_throws(
        ErrorException(
            "The builtin _EMPTY_VECTOR was modified by the user. If the gradient vector is empty, do not modify it in a callback.",
        ),
        optimize(opt, [0.0]),
    )
    @test isempty(NLopt._EMPTY_VECTOR)
    return
end

end  # module

TestCAPI.runtests()

# Copyright (c) 2019 Mathieu Besançon, Oscar Dowson, and contributors
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

using Clang.Generators
import NLopt_jll

c_api = joinpath(NLopt_jll.artifact_dir, "include", "nlopt.h")

build!(
    create_context(
        [c_api],
        get_default_args(),
        load_options(joinpath(@__DIR__, "generate.toml")),
    ),
)

header = """
# Copyright (c) 2013: Steven G. Johnson and contributors
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

#! format: off

"""

filename = joinpath(@__DIR__, "..", "src", "libnlopt.jl")
contents = read(filename, String)
contents = replace(
    contents,
    "const nlopt_opt = Ptr{nlopt_opt_s}" => "const nlopt_opt = Ptr{Cvoid}",
)
write(filename, header * contents)

# Copyright (c) 2013: Steven G. Johnson and contributors
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module TestMOIWrapper

using NLopt
using Test
import MathOptInterface as MOI

function runtests()
    for name in names(@__MODULE__; all = true)
        if startswith("$(name)", "test_")
            @testset "$(name)" begin
                getfield(@__MODULE__, name)()
            end
        end
    end
    return
end

function test_runtests()
    model = MOI.instantiate(
        NLopt.Optimizer;
        with_bridge_type = Float64,
        with_cache_type = Float64,
    )
    MOI.set(model, MOI.RawOptimizerAttribute("algorithm"), :LD_SLSQP)
    MOI.set(model, MOI.RawOptimizerAttribute("maxtime"), 10.0)
    other_failures = Any[]
    if Sys.WORD_SIZE == 32
        push!(other_failures, r"^test_constraint_qcp_duplicate_diagonal$")
    end
    MOI.Test.runtests(
        model,
        MOI.Test.Config(;
            optimal_status = MOI.LOCALLY_SOLVED,
            atol = 1e-2,
            rtol = 1e-2,
            exclude = Any[
                MOI.ConstraintBasisStatus,
                MOI.ConstraintDual,
                MOI.DualObjectiveValue,
                MOI.ObjectiveBound,
                MOI.NLPBlockDual,
                MOI.VariableBasisStatus,
            ],
        );
        exclude = [
            # Issues related to detecting infeasibility
            r"^test_conic_NormInfinityCone_INFEASIBLE$",
            r"^test_conic_NormOneCone_INFEASIBLE$",
            r"^test_conic_linear_INFEASIBLE$",
            r"^test_conic_linear_INFEASIBLE_2$",
            r"^test_infeasible_MIN_SENSE$",
            r"^test_infeasible_MIN_SENSE_offset$",
            r"^test_linear_DUAL_INFEASIBLE$",
            r"^test_linear_DUAL_INFEASIBLE_2$",
            r"^test_linear_INFEASIBLE$",
            r"^test_linear_INFEASIBLE_2$",
            r"^test_solve_TerminationStatus_DUAL_INFEASIBLE$",
            # ArgumentError: invalid NLopt arguments: too many equality constraints
            r"^test_linear_VectorAffineFunction_empty_row$",
            # Evaluated: MathOptInterface.ALMOST_LOCALLY_SOLVED == MathOptInterface.LOCALLY_SOLVED
            r"^test_linear_add_constraints$",
            # NLopt#31
            r"^test_nonlinear_invalid$",
            # TODO(odow): wrong solutions?
            r"^test_quadratic_SecondOrderCone_basic$",
            r"^test_quadratic_constraint_integration$",
            # Perhaps an expected failure because the problem is non-convex
            r"^test_quadratic_nonconvex_constraint_basic$",
            r"^test_quadratic_nonconvex_constraint_integration$",
            # A whole bunch of issues to diagnose here
            "test_basic_VectorNonlinearFunction_",
            # INVALID_OPTION?
            r"^test_nonlinear_expression_hs109$",
            other_failures...,
        ],
    )
    return
end

function test_list_of_model_attributes_set()
    attr = MOI.ListOfModelAttributesSet()
    model = NLopt.Optimizer()
    ret = MOI.AbstractModelAttribute[]
    @test MOI.get(model, attr) == ret
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    push!(ret, MOI.ObjectiveSense())
    @test MOI.get(model, attr) == ret
    x = MOI.add_variable(model)
    MOI.set(model, MOI.ObjectiveFunction{MOI.VariableIndex}(), x)
    push!(ret, MOI.ObjectiveFunction{MOI.VariableIndex}())
    @test MOI.get(model, attr) == ret
    return
end

function test_list_and_number_of_constraints()
    model = NLopt.Optimizer()
    x = MOI.add_variable(model)
    F1, S1 = MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}
    F2, S2 = MOI.ScalarQuadraticFunction{Float64}, MOI.LessThan{Float64}
    @test MOI.get(model, MOI.NumberOfConstraints{F1,S1}()) == 0
    @test MOI.get(model, MOI.NumberOfConstraints{F2,S2}()) == 0
    @test MOI.get(model, MOI.ListOfConstraintIndices{F1,S1}()) == []
    @test MOI.get(model, MOI.ListOfConstraintIndices{F2,S2}()) == []
    c1 = MOI.add_constraint(model, 1.0 * x, MOI.EqualTo(2.0))
    @test MOI.get(model, MOI.NumberOfConstraints{F1,S1}()) == 1
    @test MOI.get(model, MOI.NumberOfConstraints{F2,S2}()) == 0
    @test MOI.get(model, MOI.ListOfConstraintIndices{F1,S1}()) == [c1]
    @test MOI.get(model, MOI.ListOfConstraintIndices{F2,S2}()) == []
    c2 = MOI.add_constraint(model, 1.0 * x * x, MOI.LessThan(2.0))
    @test MOI.get(model, MOI.NumberOfConstraints{F1,S1}()) == 1
    @test MOI.get(model, MOI.NumberOfConstraints{F2,S2}()) == 1
    @test MOI.get(model, MOI.ListOfConstraintIndices{F1,S1}()) == [c1]
    @test MOI.get(model, MOI.ListOfConstraintIndices{F2,S2}()) == [c2]
    @test MOI.get(model, MOI.ConstraintSet(), c1) == MOI.EqualTo(2.0)
    @test MOI.get(model, MOI.ConstraintSet(), c2) == MOI.LessThan(2.0)
    return
end

function test_raw_optimizer_attribute()
    model = NLopt.Optimizer()
    attr = MOI.RawOptimizerAttribute("algorithm")
    @test MOI.supports(model, attr)
    @test MOI.get(model, attr) == :none
    MOI.set(model, attr, :LD_MMA)
    @test MOI.get(model, attr) == :LD_MMA
    bad_attr = MOI.RawOptimizerAttribute("foobar")
    @test !MOI.supports(model, bad_attr)
    @test_throws MOI.GetAttributeNotAllowed MOI.get(model, bad_attr)
    return
end

function test_list_of_variable_attributes_set()
    model = NLopt.Optimizer()
    @test MOI.get(model, MOI.ListOfVariableAttributesSet()) ==
          MOI.AbstractVariableAttribute[]
    x = MOI.add_variables(model, 2)
    MOI.supports(model, MOI.VariablePrimalStart(), MOI.VariableIndex)
    MOI.set(model, MOI.VariablePrimalStart(), x[2], 1.0)
    @test MOI.get(model, MOI.ListOfVariableAttributesSet()) ==
          MOI.AbstractVariableAttribute[MOI.VariablePrimalStart()]
    @test MOI.get(model, MOI.VariablePrimalStart(), x[1]) === nothing
    @test MOI.get(model, MOI.VariablePrimalStart(), x[2]) === 1.0
    return
end

function test_list_of_constraint_attributes_set()
    model = NLopt.Optimizer()
    F, S = MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64}
    @test MOI.get(model, MOI.ListOfConstraintAttributesSet{F,S}()) ==
          MOI.AbstractConstraintAttribute[]
    return
end

function test_raw_optimizer_attribute_in_optimize()
    model = NLopt.Optimizer()
    x = MOI.add_variables(model, 2)
    f = (x[1] - 2.0) * (x[1] - 2.0) + (x[2] + 1.0)^2# * (x[2] + 1)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    for (k, v) in (
        "algorithm" => :LD_SLSQP,
        "stopval" => 1.0,
        "ftol_rel" => 1e-6,
        "ftol_abs" => 1e-6,
        "xtol_rel" => 1e-6,
        "xtol_abs" => 1e-6,
        "maxeval" => 100,
        "maxtime" => 60.0,
        "initial_step" => [0.1, 0.1],
        "population" => 10,
        "seed" => 1234,
        "vector_storage" => 3,
    )
        attr = MOI.RawOptimizerAttribute(k)
        MOI.set(model, attr, v)
    end
    MOI.optimize!(model)
    @test ≈(MOI.get.(model, MOI.VariablePrimal(), x), [2.0, -1.0]; atol = 1e-4)
    return
end

function test_local_optimizer_Symbol()
    model = NLopt.Optimizer()
    x = MOI.add_variables(model, 2)
    f = (x[1] - 2.0) * (x[1] - 2.0) + (x[2] + 1.0) * (x[2] + 1.0)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.set(model, MOI.RawOptimizerAttribute("algorithm"), :AUGLAG)
    attr = MOI.RawOptimizerAttribute("local_optimizer")
    @test MOI.get(model, attr) === nothing
    MOI.set(model, attr, :LD_SLSQP)
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) isa MOI.TerminationStatusCode
    return
end

function test_local_optimizer_Opt()
    model = NLopt.Optimizer()
    x = MOI.add_variables(model, 2)
    f = (x[1] - 2.0) * (x[1] - 2.0) + (x[2] + 1.0) * (x[2] + 1.0)
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{typeof(f)}(), f)
    MOI.set(model, MOI.RawOptimizerAttribute("algorithm"), :GD_MLSL)
    attr = MOI.RawOptimizerAttribute("local_optimizer")
    @test MOI.get(model, attr) === nothing
    MOI.set(model, attr, NLopt.Opt(:LD_MMA, 2))
    MOI.optimize!(model)
    @test MOI.get(model, MOI.TerminationStatus()) isa MOI.TerminationStatusCode
    return
end

function test_get_objective_function()
    model = NLopt.Optimizer()
    x = MOI.add_variable(model)
    MOI.set(model, MOI.ObjectiveFunction{MOI.VariableIndex}(), x)
    @test MOI.get(model, MOI.ObjectiveFunction{MOI.VariableIndex}()) == x
    F = MOI.ScalarAffineFunction{Float64}
    @test isapprox(MOI.get(model, MOI.ObjectiveFunction{F}()), 1.0 * x)
    return
end

function test_ScalarNonlinearFunction_mix_apis_nlpblock_last()
    model = NLopt.Optimizer()
    x = MOI.add_variable(model)
    f = MOI.ScalarNonlinearFunction(:log, Any[x])
    MOI.add_constraint(model, f, MOI.LessThan(1.0))
    evaluator = MOI.Test.HS071(false, false)
    bounds = MOI.NLPBoundsPair.([25.0, 40.0], [Inf, 40.0])
    block = MOI.NLPBlockData(bounds, evaluator, true)
    @test_throws(
        ErrorException("Cannot mix the new and legacy nonlinear APIs"),
        MOI.set(model, MOI.NLPBlock(), block),
    )
    return
end

function test_ScalarNonlinearFunction_mix_apis_nlpblock_first()
    model = NLopt.Optimizer()
    x = MOI.add_variable(model)
    evaluator = MOI.Test.HS071(false, false)
    bounds = MOI.NLPBoundsPair.([25.0, 40.0], [Inf, 40.0])
    block = MOI.NLPBlockData(bounds, evaluator, true)
    MOI.set(model, MOI.NLPBlock(), block)
    f = MOI.ScalarNonlinearFunction(:log, Any[x])
    @test_throws(
        ErrorException("Cannot mix the new and legacy nonlinear APIs"),
        MOI.add_constraint(model, f, MOI.LessThan(1.0)),
    )
    return
end

function test_ScalarNonlinearFunction_is_valid()
    model = NLopt.Optimizer()
    x = MOI.add_variable(model)
    F, S = MOI.ScalarNonlinearFunction, MOI.EqualTo{Float64}
    @test MOI.is_valid(model, MOI.ConstraintIndex{F,S}(1)) == false
    f = MOI.ScalarNonlinearFunction(:sin, Any[x])
    c = MOI.add_constraint(model, f, MOI.EqualTo(0.0))
    @test c isa MOI.ConstraintIndex{F,S}
    @test MOI.is_valid(model, c) == true
    return
end

function test_ScalarNonlinearFunction_ObjectiveFunctionType()
    model = NLopt.Optimizer()
    x = MOI.add_variable(model)
    f = MOI.ScalarNonlinearFunction(:log, Any[x])
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    F = MOI.ScalarNonlinearFunction
    MOI.set(model, MOI.ObjectiveFunction{F}(), f)
    @test MOI.get(model, MOI.ObjectiveFunctionType()) == F
    return
end

function test_AutomaticDifferentiationBackend()
    model = NLopt.Optimizer()
    attr = MOI.AutomaticDifferentiationBackend()
    @test MOI.supports(model, attr)
    @test MOI.get(model, attr) == MOI.Nonlinear.SparseReverseMode()
    MOI.set(model, attr, MOI.Nonlinear.ExprGraphOnly())
    @test MOI.get(model, attr) == MOI.Nonlinear.ExprGraphOnly()
    return
end

function test_ScalarNonlinearFunction_LessThan()
    model = NLopt.Optimizer()
    MOI.set(model, MOI.RawOptimizerAttribute("algorithm"), :LD_SLSQP)
    x = MOI.add_variable(model)
    # Needed for NLopt#31
    MOI.set(model, MOI.VariablePrimalStart(), x, 1.0)
    f = MOI.ScalarNonlinearFunction(:log, Any[x])
    MOI.add_constraint(model, f, MOI.LessThan(2.0))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{MOI.VariableIndex}(), x)
    MOI.optimize!(model)
    @test isapprox(MOI.get(model, MOI.VariablePrimal(), x), exp(2); atol = 1e-4)
    return
end

function test_ScalarNonlinearFunction_GreaterThan()
    model = NLopt.Optimizer()
    MOI.set(model, MOI.RawOptimizerAttribute("algorithm"), :LD_SLSQP)
    x = MOI.add_variable(model)
    # Needed for NLopt#31
    MOI.set(model, MOI.VariablePrimalStart(), x, 1.0)
    f = MOI.ScalarNonlinearFunction(:log, Any[x])
    MOI.add_constraint(model, f, MOI.GreaterThan(2.0))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{MOI.VariableIndex}(), x)
    MOI.optimize!(model)
    @test isapprox(MOI.get(model, MOI.VariablePrimal(), x), exp(2); atol = 1e-4)
    return
end

function test_ScalarNonlinearFunction_Interval()
    model = NLopt.Optimizer()
    MOI.set(model, MOI.RawOptimizerAttribute("algorithm"), :LD_SLSQP)
    x = MOI.add_variable(model)
    # Needed for NLopt#31
    MOI.set(model, MOI.VariablePrimalStart(), x, 1.0)
    f = MOI.ScalarNonlinearFunction(:log, Any[x])
    MOI.add_constraint(model, f, MOI.Interval(1.0, 2.0))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MAX_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{MOI.VariableIndex}(), x)
    MOI.optimize!(model)
    @test isapprox(MOI.get(model, MOI.VariablePrimal(), x), exp(2); atol = 1e-4)
    return
end

function test_ScalarNonlinearFunction_derivative_free()
    model = NLopt.Optimizer()
    MOI.set(model, MOI.RawOptimizerAttribute("algorithm"), :LN_COBYLA)
    x = MOI.add_variable(model)
    # Needed for NLopt#31
    MOI.set(model, MOI.VariablePrimalStart(), x, 1.0)
    f = MOI.ScalarNonlinearFunction(:log, Any[x])
    MOI.add_constraint(model, f, MOI.GreaterThan(2.0))
    MOI.set(model, MOI.ObjectiveSense(), MOI.MIN_SENSE)
    MOI.set(model, MOI.ObjectiveFunction{MOI.VariableIndex}(), x)
    MOI.optimize!(model)
    @test isapprox(MOI.get(model, MOI.VariablePrimal(), x), exp(2); atol = 1e-4)
    return
end

function test_ListOfSupportedNonlinearOperators()
    model = NLopt.Optimizer()
    ops = MOI.get(model, MOI.ListOfSupportedNonlinearOperators())
    @test ops isa Vector{Symbol}
    @test :|| in ops
    @test :ifelse in ops
    @test :sin in ops
    @test !(:f in ops)
    f(x) = x^2
    MOI.set(model, MOI.UserDefinedFunction(:f, 1), (f,))
    @test :f in MOI.get(model, MOI.ListOfSupportedNonlinearOperators())
    return
end

end  # module

TestMOIWrapper.runtests()

# Copyright (c) 2013: Steven G. Johnson and contributors
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

include("C_API.jl")
include("MOI_wrapper.jl")

# Copyright (c) 2013: Steven G. Johnson and contributors
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

module NLoptMathOptInterfaceExt

import MathOptInterface as MOI
import NLopt

function __init__()
    # we need to add extension types back to the toplevel module
    @static if VERSION >= v"1.9"
        setglobal!(NLopt, :Optimizer, Optimizer)
    end
    return
end

mutable struct _ConstraintInfo{F,S}
    func::F
    set::S
end

"""
    Optimizer()

Create a new Optimizer object.
"""
mutable struct Optimizer <: MOI.AbstractOptimizer
    inner::Union{NLopt.Opt,Nothing}
    variables::MOI.Utilities.VariablesContainer{Float64}
    starting_values::Vector{Union{Nothing,Float64}}
    nlp_data::MOI.NLPBlockData
    nlp_model::Union{Nothing,MOI.Nonlinear.Model}
    ad_backend::MOI.Nonlinear.AbstractAutomaticDifferentiation
    sense::Union{Nothing,MOI.OptimizationSense}
    objective::Union{
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
        Nothing,
    }
    linear_le_constraints::Vector{
        _ConstraintInfo{
            MOI.ScalarAffineFunction{Float64},
            MOI.LessThan{Float64},
        },
    }
    linear_eq_constraints::Vector{
        _ConstraintInfo{MOI.ScalarAffineFunction{Float64},MOI.EqualTo{Float64}},
    }
    quadratic_le_constraints::Vector{
        _ConstraintInfo{
            MOI.ScalarQuadraticFunction{Float64},
            MOI.LessThan{Float64},
        },
    }
    quadratic_eq_constraints::Vector{
        _ConstraintInfo{
            MOI.ScalarQuadraticFunction{Float64},
            MOI.EqualTo{Float64},
        },
    }
    # Parameters.
    silent::Bool
    options::Dict{String,Any}
    # Solution attributes.
    objective_value::Float64
    solution::Vector{Float64}
    status::Symbol
    solve_time::Float64

    function Optimizer()
        return new(
            nothing,
            MOI.Utilities.VariablesContainer{Float64}(),
            Union{Nothing,Float64}[],
            MOI.NLPBlockData([], _EmptyNLPEvaluator(), false),
            nothing,
            MOI.Nonlinear.SparseReverseMode(),
            nothing,
            nothing,
            _ConstraintInfo{
                MOI.ScalarAffineFunction{Float64},
                MOI.LessThan{Float64},
            }[],
            _ConstraintInfo{
                MOI.ScalarAffineFunction{Float64},
                MOI.EqualTo{Float64},
            }[],
            _ConstraintInfo{
                MOI.ScalarQuadraticFunction{Float64},
                MOI.LessThan{Float64},
            }[],
            _ConstraintInfo{
                MOI.ScalarQuadraticFunction{Float64},
                MOI.EqualTo{Float64},
            }[],
            false,
            copy(_DEFAULT_OPTIONS),
            NaN,
            Float64[],
            :NOT_CALLED,
            NaN,
        )
    end
end

struct _EmptyNLPEvaluator <: MOI.AbstractNLPEvaluator end

MOI.initialize(::_EmptyNLPEvaluator, ::Vector{Symbol}) = nothing

MOI.eval_constraint(::_EmptyNLPEvaluator, g, x) = nothing

MOI.eval_constraint_jacobian(::_EmptyNLPEvaluator, J, x) = nothing

function MOI.empty!(model::Optimizer)
    model.inner = nothing
    MOI.empty!(model.variables)
    empty!(model.starting_values)
    model.nlp_data = MOI.NLPBlockData([], _EmptyNLPEvaluator(), false)
    model.nlp_model = nothing
    model.sense = nothing
    model.objective = nothing
    empty!(model.linear_le_constraints)
    empty!(model.linear_eq_constraints)
    empty!(model.quadratic_le_constraints)
    empty!(model.quadratic_eq_constraints)
    model.status = :NOT_CALLED
    return
end

function MOI.is_empty(model::Optimizer)
    return MOI.is_empty(model.variables) &&
           isempty(model.starting_values) &&
           model.nlp_data.evaluator isa _EmptyNLPEvaluator &&
           model.nlp_model === nothing &&
           model.sense == nothing &&
           isempty(model.linear_le_constraints) &&
           isempty(model.linear_eq_constraints) &&
           isempty(model.quadratic_le_constraints) &&
           isempty(model.quadratic_eq_constraints)
end

function MOI.get(model::Optimizer, ::MOI.ListOfModelAttributesSet)
    ret = MOI.AbstractModelAttribute[]
    if model.sense !== nothing
        push!(ret, MOI.ObjectiveSense())
    end
    if model.objective !== nothing
        F = MOI.get(model, MOI.ObjectiveFunctionType())
        push!(ret, MOI.ObjectiveFunction{F}())
    end
    return ret
end

MOI.supports_incremental_interface(::Optimizer) = true

function MOI.copy_to(model::Optimizer, src::MOI.ModelLike)
    return MOI.Utilities.default_copy_to(model, src)
end

MOI.get(::Optimizer, ::MOI.SolverName) = "NLopt"

MOI.get(::Optimizer, ::MOI.SolverVersion) = "$(NLopt.version())"

function _constraints(
    model,
    ::Type{<:MOI.ScalarAffineFunction},
    ::Type{<:MOI.LessThan},
)
    return model.linear_le_constraints
end

function _constraints(
    model,
    ::Type{<:MOI.ScalarAffineFunction},
    ::Type{<:MOI.EqualTo},
)
    return model.linear_eq_constraints
end

function _constraints(
    model,
    ::Type{<:MOI.ScalarQuadraticFunction},
    ::Type{<:MOI.LessThan},
)
    return model.quadratic_le_constraints
end

function _constraints(
    model,
    ::Type{<:MOI.ScalarQuadraticFunction},
    ::Type{<:MOI.EqualTo},
)
    return model.quadratic_eq_constraints
end

function MOI.supports_constraint(
    ::Optimizer,
    ::Type{
        <:Union{
            MOI.ScalarAffineFunction{Float64},
            MOI.ScalarQuadraticFunction{Float64},
        },
    },
    ::Type{<:Union{MOI.LessThan{Float64},MOI.EqualTo{Float64}}},
)
    return true
end

function MOI.get(
    model::Optimizer,
    ::MOI.NumberOfConstraints{F,S},
) where {
    F<:Union{
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
    S<:Union{MOI.LessThan{Float64},MOI.EqualTo{Float64}},
}
    return length(_constraints(model, F, S))
end

function MOI.get(model::Optimizer, attr::MOI.ListOfConstraintTypesPresent)
    constraints = MOI.get(model.variables, attr)
    function _check(model, F, S)
        if !isempty(_constraints(model, F, S))
            push!(constraints, (F, S))
        end
    end
    _check(model, MOI.ScalarAffineFunction{Float64}, MOI.LessThan{Float64})
    _check(model, MOI.ScalarAffineFunction{Float64}, MOI.EqualTo{Float64})
    _check(model, MOI.ScalarQuadraticFunction{Float64}, MOI.LessThan{Float64})
    _check(model, MOI.ScalarQuadraticFunction{Float64}, MOI.EqualTo{Float64})
    return constraints
end

function MOI.get(
    model::Optimizer,
    ::MOI.ListOfConstraintIndices{F,S},
) where {
    F<:Union{
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
    S<:Union{MOI.LessThan{Float64},MOI.EqualTo{Float64}},
}
    return MOI.ConstraintIndex{F,S}.(eachindex(_constraints(model, F, S)))
end

function MOI.get(
    model::Optimizer,
    ::MOI.ConstraintFunction,
    c::MOI.ConstraintIndex{F,S},
) where {
    F<:Union{
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
    S<:Union{MOI.LessThan{Float64},MOI.EqualTo{Float64}},
}
    return copy(_constraints(model, F, S)[c.value].func)
end

function MOI.get(
    model::Optimizer,
    ::MOI.ConstraintSet,
    c::MOI.ConstraintIndex{F,S},
) where {
    F<:Union{
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
    S<:Union{MOI.LessThan{Float64},MOI.EqualTo{Float64}},
}
    return _constraints(model, F, S)[c.value].set
end

# ObjectiveSense

MOI.supports(::Optimizer, ::MOI.ObjectiveSense) = true

function MOI.set(
    model::Optimizer,
    ::MOI.ObjectiveSense,
    sense::MOI.OptimizationSense,
)
    model.sense = sense
    return
end

function MOI.get(model::Optimizer, ::MOI.ObjectiveSense)
    return something(model.sense, MOI.FEASIBILITY_SENSE)
end

# MOI.Silent

MOI.supports(::Optimizer, ::MOI.Silent) = true

function MOI.set(model::Optimizer, ::MOI.Silent, value::Bool)
    model.silent = value
    return
end

MOI.get(model::Optimizer, ::MOI.Silent) = model.silent

# MOI.TimeLimitSec

MOI.supports(::Optimizer, ::MOI.TimeLimitSec) = true

function MOI.set(model::Optimizer, ::MOI.TimeLimitSec, value::Real)
    MOI.set(model, MOI.RawOptimizerAttribute("max_cpu_time"), Float64(value))
    return
end

function MOI.set(model::Optimizer, ::MOI.TimeLimitSec, ::Nothing)
    delete!(model.options, "max_cpu_time")
    return
end

function MOI.get(model::Optimizer, ::MOI.TimeLimitSec)
    return get(model.options, "max_cpu_time", nothing)
end

# MOI.RawOptimizerAttribute

const _DEFAULT_OPTIONS = Dict{String,Any}(
    "algorithm" => :none,
    "stopval" => NaN,
    "ftol_rel" => 1e-7,
    "ftol_abs" => NaN,
    "xtol_rel" => 1e-7,
    "xtol_abs" => nothing,
    "constrtol_abs" => 1e-7,
    "maxeval" => 0,
    "maxtime" => 0.0,
    "initial_step" => nothing,
    "population" => 0,
    "seed" => nothing,
    "vector_storage" => 0,
    "local_optimizer" => nothing,
)

function MOI.supports(::Optimizer, p::MOI.RawOptimizerAttribute)
    # TODO(odow): this ignores other algorithm-specific parameters?
    return haskey(_DEFAULT_OPTIONS, p.name)
end

function MOI.set(model::Optimizer, p::MOI.RawOptimizerAttribute, value)
    model.options[p.name] = value
    return
end

function MOI.get(model::Optimizer, p::MOI.RawOptimizerAttribute)
    if !haskey(model.options, p.name)
        msg = "RawOptimizerAttribute with name $(p.name) is not set."
        throw(MOI.GetAttributeNotAllowed(p, msg))
    end
    return model.options[p.name]
end

# Variables

function MOI.get(model::Optimizer, ::MOI.ListOfVariableAttributesSet)
    ret = MOI.AbstractVariableAttribute[]
    if any(!isnothing, model.starting_values)
        push!(ret, MOI.VariablePrimalStart())
    end
    return ret
end

function MOI.add_variable(model::Optimizer)
    push!(model.starting_values, nothing)
    return MOI.add_variable(model.variables)
end

function MOI.supports_constraint(
    ::Optimizer,
    ::Type{MOI.VariableIndex},
    ::Type{
        <:Union{
            MOI.LessThan{Float64},
            MOI.GreaterThan{Float64},
            MOI.EqualTo{Float64},
            MOI.Interval{Float64},
        },
    },
)
    return true
end

function MOI.get(
    model::Optimizer,
    attr::Union{
        MOI.NumberOfVariables,
        MOI.ListOfVariableIndices,
        MOI.NumberOfConstraints{MOI.VariableIndex},
        MOI.ListOfConstraintIndices{MOI.VariableIndex},
    },
)
    return MOI.get(model.variables, attr)
end

function MOI.get(
    model::Optimizer,
    attr::Union{MOI.ConstraintFunction,MOI.ConstraintSet},
    ci::MOI.ConstraintIndex{MOI.VariableIndex},
)
    return MOI.get(model.variables, attr, ci)
end

function MOI.is_valid(
    model::Optimizer,
    index::Union{MOI.VariableIndex,MOI.ConstraintIndex{MOI.VariableIndex}},
)
    return MOI.is_valid(model.variables, index)
end

function MOI.add_constraint(
    model::Optimizer,
    vi::MOI.VariableIndex,
    set::Union{
        MOI.LessThan{Float64},
        MOI.GreaterThan{Float64},
        MOI.EqualTo{Float64},
        MOI.Interval{Float64},
    },
)
    return MOI.add_constraint(model.variables, vi, set)
end

function MOI.set(
    model::Optimizer,
    attr::MOI.ConstraintSet,
    ci::MOI.ConstraintIndex{MOI.VariableIndex,S},
    set::S,
) where {S}
    return MOI.set(model.variables, attr, ci, set)
end

function MOI.delete(
    model::Optimizer,
    ci::MOI.ConstraintIndex{MOI.VariableIndex},
)
    return MOI.delete(model.variables, ci)
end

# constraints

function MOI.get(::Optimizer, ::MOI.ListOfConstraintAttributesSet)
    return MOI.AbstractConstraintAttribute[]
end

function MOI.is_valid(
    model::Optimizer,
    ci::MOI.ConstraintIndex{F,S},
) where {
    F<:Union{
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
    S<:Union{MOI.LessThan{Float64},MOI.EqualTo{Float64}},
}
    return 1 <= ci.value <= length(_constraints(model, F, S))
end

function _check_inbounds(model, f::MOI.VariableIndex)
    return MOI.throw_if_not_valid(model, f)
end

function _check_inbounds(model, f::MOI.ScalarAffineFunction{Float64})
    for term in f.terms
        MOI.throw_if_not_valid(model, term.variable)
    end
    return
end

function _check_inbounds(model, f::MOI.ScalarQuadraticFunction{Float64})
    for term in f.affine_terms
        MOI.throw_if_not_valid(model, term.variable)
    end
    for term in f.quadratic_terms
        MOI.throw_if_not_valid(model, term.variable_1)
        MOI.throw_if_not_valid(model, term.variable_2)
    end
    return
end

function MOI.add_constraint(
    model::Optimizer,
    func::F,
    set::S,
) where {
    F<:Union{
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
    S<:Union{MOI.LessThan{Float64},MOI.EqualTo{Float64}},
}
    _check_inbounds(model, func)
    constraints = _constraints(model, F, S)
    push!(constraints, _ConstraintInfo(func, set))
    return MOI.ConstraintIndex{F,S}(length(constraints))
end

# MOI.VariablePrimalStart

function MOI.supports(
    ::Optimizer,
    ::MOI.VariablePrimalStart,
    ::Type{MOI.VariableIndex},
)
    return true
end

function MOI.set(
    model::Optimizer,
    ::MOI.VariablePrimalStart,
    vi::MOI.VariableIndex,
    value::Union{Real,Nothing},
)
    MOI.throw_if_not_valid(model, vi)
    model.starting_values[vi.value] = value
    return
end

function MOI.get(
    model::Optimizer,
    ::MOI.VariablePrimalStart,
    vi::MOI.VariableIndex,
)
    MOI.throw_if_not_valid(model, vi)
    return model.starting_values[vi.value]
end

# MOI.NLPBlock

MOI.supports(::Optimizer, ::MOI.NLPBlock) = true

function MOI.set(model::Optimizer, ::MOI.NLPBlock, nlp_data::MOI.NLPBlockData)
    if model.nlp_model !== nothing
        error("Cannot mix the new and legacy nonlinear APIs")
    end
    model.nlp_data = nlp_data
    return
end

# MOI.ObjectiveFunction

function MOI.supports(
    ::Optimizer,
    ::MOI.ObjectiveFunction{
        <:Union{
            MOI.VariableIndex,
            MOI.ScalarAffineFunction{Float64},
            MOI.ScalarQuadraticFunction{Float64},
        },
    },
)
    return true
end

function MOI.get(model::Optimizer, ::MOI.ObjectiveFunctionType)
    if model.nlp_model !== nothing && model.nlp_model.objective !== nothing
        return MOI.ScalarNonlinearFunction
    end
    return typeof(model.objective)
end

function MOI.get(model::Optimizer, ::MOI.ObjectiveFunction{F}) where {F}
    return convert(F, model.objective)::F
end

function MOI.set(
    model::Optimizer,
    ::MOI.ObjectiveFunction{F},
    func::F,
) where {
    F<:Union{
        MOI.VariableIndex,
        MOI.ScalarAffineFunction{Float64},
        MOI.ScalarQuadraticFunction{Float64},
    },
}
    _check_inbounds(model, func)
    model.objective = func
    if model.nlp_model !== nothing
        MOI.Nonlinear.set_objective(model.nlp_model, nothing)
    end
    return
end

# ScalarNonlinearFunction

function _init_nlp_model(model)
    if model.nlp_model === nothing
        if !(model.nlp_data.evaluator isa _EmptyNLPEvaluator)
            error("Cannot mix the new and legacy nonlinear APIs")
        end
        model.nlp_model = MOI.Nonlinear.Model()
    end
    return
end

function MOI.is_valid(
    model::Optimizer,
    ci::MOI.ConstraintIndex{MOI.ScalarNonlinearFunction,S},
) where {
    S<:Union{
        MOI.EqualTo{Float64},
        MOI.LessThan{Float64},
        MOI.GreaterThan{Float64},
        MOI.Interval{Float64},
    },
}
    if model.nlp_model === nothing
        return false
    end
    index = MOI.Nonlinear.ConstraintIndex(ci.value)
    return MOI.is_valid(model.nlp_model, index)
end

function MOI.supports_constraint(
    ::Optimizer,
    ::Type{MOI.ScalarNonlinearFunction},
    ::Type{S},
) where {
    S<:Union{
        MOI.EqualTo{Float64},
        MOI.LessThan{Float64},
        MOI.GreaterThan{Float64},
        MOI.Interval{Float64},
    },
}
    return true
end

function MOI.add_constraint(
    model::Optimizer,
    f::MOI.ScalarNonlinearFunction,
    set::Union{
        MOI.EqualTo{Float64},
        MOI.LessThan{Float64},
        MOI.GreaterThan{Float64},
        MOI.Interval{Float64},
    },
)
    _init_nlp_model(model)
    index = MOI.Nonlinear.add_constraint(model.nlp_model, f, set)
    return MOI.ConstraintIndex{typeof(f),typeof(set)}(index.value)
end

function MOI.supports(
    ::Optimizer,
    ::MOI.ObjectiveFunction{MOI.ScalarNonlinearFunction},
)
    return true
end

function MOI.set(
    model::Optimizer,
    attr::MOI.ObjectiveFunction{MOI.ScalarNonlinearFunction},
    func::MOI.ScalarNonlinearFunction,
)
    _init_nlp_model(model)
    MOI.Nonlinear.set_objective(model.nlp_model, func)
    return
end

### MOI.AutomaticDifferentiationBackend

MOI.supports(::Optimizer, ::MOI.AutomaticDifferentiationBackend) = true

function MOI.get(model::Optimizer, ::MOI.AutomaticDifferentiationBackend)
    return model.ad_backend
end

function MOI.set(
    model::Optimizer,
    ::MOI.AutomaticDifferentiationBackend,
    backend::MOI.Nonlinear.AbstractAutomaticDifferentiation,
)
    model.ad_backend = backend
    return
end

### MOI.UserDefinedFunction

MOI.supports(model::Optimizer, ::MOI.UserDefinedFunction) = true

function MOI.set(model::Optimizer, attr::MOI.UserDefinedFunction, args)
    _init_nlp_model(model)
    MOI.Nonlinear.register_operator(
        model.nlp_model,
        attr.name,
        attr.arity,
        args...,
    )
    return
end

### MOI.ListOfSupportedNonlinearOperators

function MOI.get(model::Optimizer, attr::MOI.ListOfSupportedNonlinearOperators)
    _init_nlp_model(model)
    return MOI.get(model.nlp_model, attr)
end

# optimize!

function _fill_gradient(grad, x, f::MOI.VariableIndex)
    grad[f.value] = 1.0
    return
end

function _fill_gradient(grad, x, f::MOI.ScalarAffineFunction{Float64})
    for term in f.terms
        grad[term.variable.value] += term.coefficient
    end
    return
end

function _fill_gradient(grad, x, f::MOI.ScalarQuadraticFunction{Float64})
    for term in f.affine_terms
        grad[term.variable.value] += term.coefficient
    end
    for term in f.quadratic_terms
        i, j = term.variable_1.value, term.variable_2.value
        grad[i] += term.coefficient * x[j]
        if i != j
            grad[j] += term.coefficient * x[i]
        end
    end
    return
end

function _fill_result(result::Vector, x, offset, constraints::Vector)
    for (i, constraint) in enumerate(constraints)
        lhs = MOI.Utilities.eval_variables(vi -> x[vi.value], constraint.func)
        result[offset+i] = lhs - MOI.constant(constraint.set)
    end
    return
end

function _fill_jacobian(jac, x, offset, term::MOI.ScalarAffineTerm)
    jac[term.variable.value, offset] += term.coefficient
    return
end

function _fill_jacobian(jac, x, offset, term::MOI.ScalarQuadraticTerm)
    i, j = term.variable_1.value, term.variable_2.value
    jac[i, offset] += term.coefficient * x[j]
    if i != j
        jac[j, offset] += term.coefficient * x[i]
    end
    return
end

function _fill_jacobian(jac, x, offset, f::MOI.ScalarAffineFunction)
    for term in f.terms
        _fill_jacobian(jac, x, offset, term)
    end
    return
end

function _fill_jacobian(jac, x, offset, f::MOI.ScalarQuadraticFunction)
    for term in f.affine_terms
        _fill_jacobian(jac, x, offset, term)
    end
    for q_term in f.quadratic_terms
        _fill_jacobian(jac, x, offset, q_term)
    end
    return
end

function _fill_jacobian(jac, x, offset, constraints::Vector)
    for (i, constraint) in enumerate(constraints)
        _fill_jacobian(jac, x, offset + i, constraint.func)
    end
    return
end

function objective_fn(model::Optimizer, x::Vector, grad::Vector)
    # The order of the conditions is important. NLP objectives override regular
    # objectives.
    if length(grad) > 0
        fill!(grad, 0.0)
        if model.sense == MOI.FEASIBILITY_SENSE
            # nothing
        elseif model.nlp_data.has_objective
            MOI.eval_objective_gradient(model.nlp_data.evaluator, grad, x)
        elseif model.objective !== nothing
            _fill_gradient(grad, x, model.objective)
        end
    end
    if model.sense == MOI.FEASIBILITY_SENSE
        return 0.0
    elseif model.nlp_data.has_objective
        return MOI.eval_objective(model.nlp_data.evaluator, x)
    elseif model.objective !== nothing
        return MOI.Utilities.eval_variables(vi -> x[vi.value], model.objective)
    end
    # No ObjectiveFunction is set, but ObjectiveSense is?
    return 0.0
end

function _initialize_options!(model::Optimizer)
    local_optimizer = model.options["local_optimizer"]
    if local_optimizer !== nothing
        num_variables = length(model.starting_values)
        local_optimizer = if local_optimizer isa Symbol
            NLopt.Opt(local_optimizer, num_variables)
        else
            @assert local_optimizer isa NLopt.Opt
            NLopt.Opt(local_optimizer.algorithm, num_variables)
        end
        NLopt.local_optimizer!(model.inner, local_optimizer)
    end
    NLopt.stopval!(model.inner, model.options["stopval"])
    if !isnan(model.options["ftol_rel"])
        NLopt.ftol_rel!(model.inner, model.options["ftol_rel"])
    end
    if !isnan(model.options["ftol_abs"])
        NLopt.ftol_abs!(model.inner, model.options["ftol_abs"])
    end
    if !isnan(model.options["xtol_rel"])
        NLopt.xtol_rel!(model.inner, model.options["xtol_rel"])
    end
    if model.options["xtol_abs"] != nothing
        NLopt.xtol_abs!(model.inner, model.options["xtol_abs"])
    end
    NLopt.maxeval!(model.inner, model.options["maxeval"])
    NLopt.maxtime!(model.inner, model.options["maxtime"])
    if model.options["initial_step"] != nothing
        NLopt.initial_step!(model.inner, model.options["initial_step"])
    end
    NLopt.population!(model.inner, model.options["population"])
    if model.options["seed"] isa Integer
        NLopt.srand(model.options["seed"])
    end
    NLopt.vector_storage!(model.inner, model.options["vector_storage"])
    return
end

function MOI.optimize!(model::Optimizer)
    num_variables = length(model.starting_values)
    model.inner = NLopt.Opt(model.options["algorithm"], num_variables)
    _initialize_options!(model)
    if model.nlp_model !== nothing
        vars = MOI.VariableIndex.(1:num_variables)
        model.nlp_data = MOI.NLPBlockData(
            MOI.Nonlinear.Evaluator(model.nlp_model, model.ad_backend, vars),
        )
    end
    NLopt.lower_bounds!(model.inner, model.variables.lower)
    NLopt.upper_bounds!(model.inner, model.variables.upper)
    nonlinear_equality_indices = findall(
        bound -> bound.lower == bound.upper,
        model.nlp_data.constraint_bounds,
    )
    nonlinear_inequality_indices = findall(
        bound -> bound.lower != bound.upper,
        model.nlp_data.constraint_bounds,
    )
    num_nlpblock_constraints = length(model.nlp_data.constraint_bounds)
    # map from eqidx/ineqidx to index in equalities/inequalities
    constrmap = zeros(Int, num_nlpblock_constraints)
    for (i, k) in enumerate(nonlinear_equality_indices)
        constrmap[k] = i
    end
    num_nlpblock_inequalities = 0
    for (i, k) in enumerate(nonlinear_inequality_indices)
        num_nlpblock_inequalities += 1
        constrmap[k] = num_nlpblock_inequalities
        bounds = model.nlp_data.constraint_bounds[k]
        if !isinf(bounds.lower) && !isinf(bounds.upper)
            # constraint has bounds on both sides, keep room for it
            num_nlpblock_inequalities += 1
        end
    end
    if string(model.options["algorithm"])[2] == 'N'
        # Derivative free optimizer chosen
        MOI.initialize(model.nlp_data.evaluator, Symbol[])
    elseif num_nlpblock_constraints > 0
        MOI.initialize(model.nlp_data.evaluator, [:Grad, :Jac])
    else
        MOI.initialize(model.nlp_data.evaluator, [:Grad])
    end
    if model.sense == MOI.MAX_SENSE
        NLopt.max_objective!(model.inner, (x, g) -> objective_fn(model, x, g))
    else
        NLopt.min_objective!(model.inner, (x, g) -> objective_fn(model, x, g))
    end
    Jac_IJ = Tuple{Int,Int}[]
    if num_nlpblock_constraints > 0
        append!(Jac_IJ, MOI.jacobian_structure(model.nlp_data.evaluator))
    end
    Jac_val = zeros(length(Jac_IJ))
    g_vec = zeros(num_nlpblock_constraints)
    function equality_constraint_fn(result::Vector, x::Vector, jac::Matrix)
        if length(jac) > 0
            fill!(jac, 0.0)
            MOI.eval_constraint_jacobian(model.nlp_data.evaluator, Jac_val, x)
            for ((row, col), val) in zip(Jac_IJ, Jac_val)
                bounds = model.nlp_data.constraint_bounds[row]
                if bounds.lower == bounds.upper
                    jac[col, constrmap[row]] += val
                end
            end
            offset = length(nonlinear_equality_indices)
            _fill_jacobian(jac, x, offset, model.linear_eq_constraints)
            offset += length(model.linear_eq_constraints)
            _fill_jacobian(jac, x, offset, model.quadratic_eq_constraints)
        end
        MOI.eval_constraint(model.nlp_data.evaluator, g_vec, x)
        for (i, index) in enumerate(nonlinear_equality_indices)
            bounds = model.nlp_data.constraint_bounds[index]
            result[i] = g_vec[index] - bounds.upper
        end
        offset = length(nonlinear_equality_indices)
        _fill_result(result, x, offset, model.linear_eq_constraints)
        offset += length(model.linear_eq_constraints)
        _fill_result(result, x, offset, model.quadratic_eq_constraints)
        return
    end
    num_equality_constraints =
        length(nonlinear_equality_indices) +
        length(model.linear_eq_constraints) +
        length(model.quadratic_eq_constraints)
    if num_equality_constraints > 0
        NLopt.equality_constraint!(
            model.inner,
            num_equality_constraints,
            equality_constraint_fn,
            model.options["constrtol_abs"],
        )
    end
    # inequalities need to be massaged a bit
    # f(x) <= u   =>  f(x) - u <= 0
    # f(x) >= l   =>  l - f(x) <= 0
    function inequality_constraint_fn(result::Vector, x::Vector, jac::Matrix)
        if length(jac) > 0
            fill!(jac, 0.0)
            MOI.eval_constraint_jacobian(model.nlp_data.evaluator, Jac_val, x)
            for ((row, col), val) in zip(Jac_IJ, Jac_val)
                bounds = model.nlp_data.constraint_bounds[row]
                if bounds.lower == bounds.upper
                    continue  # This is an equality constraint
                elseif isinf(bounds.lower)  # upper bound
                    jac[col, constrmap[row]] += val
                elseif isinf(bounds.upper)  # lower bound
                    jac[col, constrmap[row]] -= val
                else  # boxed
                    jac[col, constrmap[row]] += val
                    jac[col, constrmap[row]+1] -= val
                end
            end
            offset = num_nlpblock_inequalities
            _fill_jacobian(jac, x, offset, model.linear_le_constraints)
            offset += length(model.linear_le_constraints)
            _fill_jacobian(jac, x, offset, model.quadratic_le_constraints)
        end
        # Fill in the result. The first entries are from NLPBlock, and the value
        # of g(x) is placed in g_vec.
        MOI.eval_constraint(model.nlp_data.evaluator, g_vec, x)
        for row in 1:num_nlpblock_constraints
            index = constrmap[row]
            bounds = model.nlp_data.constraint_bounds[row]
            if bounds.lower == bounds.upper
                continue  # This is an equality constraint
            elseif isinf(bounds.lower)  # g(x) <= u --> g(x) - u <= 0
                result[index] = g_vec[row] - bounds.upper
            elseif isinf(bounds.upper)  # g(x) >= l --> l - g(x) <= 0
                result[index] = bounds.lower - g_vec[row]
            else  # l <= g(x) <= u
                result[index] = g_vec[row] - bounds.upper
                result[index+1] = bounds.lower - g_vec[row]
            end
        end
        offset = num_nlpblock_inequalities
        _fill_result(result, x, offset, model.linear_le_constraints)
        offset += length(model.linear_le_constraints)
        _fill_result(result, x, offset, model.quadratic_le_constraints)
        return
    end
    num_inequality_constraints =
        num_nlpblock_inequalities +
        length(model.linear_le_constraints) +
        length(model.quadratic_le_constraints)
    if num_inequality_constraints > 0
        NLopt.inequality_constraint!(
            model.inner,
            num_inequality_constraints,
            inequality_constraint_fn,
            model.options["constrtol_abs"],
        )
    end
    # Set MOI.VariablePrimalStart, clamping to bound nearest 0 if not given.
    model.solution = something.(
        model.starting_values,
        clamp.(0.0, model.variables.lower, model.variables.upper),
    )
    start_time = time()
    model.objective_value, _, model.status =
        NLopt.optimize!(model.inner, model.solution)
    model.solve_time = time() - start_time
    return
end

const _STATUS_MAP = Dict(
    :NOT_CALLED => (MOI.OPTIMIZE_NOT_CALLED, MOI.NO_SOLUTION),
    # The order here matches the nlopt_result enum
    :FAILURE => (MOI.OTHER_ERROR, MOI.UNKNOWN_RESULT_STATUS),
    :INVALID_ARGS => (MOI.INVALID_OPTION, MOI.UNKNOWN_RESULT_STATUS),
    :OUT_OF_MEMORY => (MOI.MEMORY_LIMIT, MOI.UNKNOWN_RESULT_STATUS),
    :ROUNDOFF_LIMITED =>
        (MOI.ALMOST_LOCALLY_SOLVED, MOI.NEARLY_FEASIBLE_POINT),
    :FORCED_STOP => (MOI.OTHER_ERROR, MOI.UNKNOWN_RESULT_STATUS),
    :SUCCESS => (MOI.LOCALLY_SOLVED, MOI.FEASIBLE_POINT),
    :STOPVAL_REACHED => (MOI.OBJECTIVE_LIMIT, MOI.UNKNOWN_RESULT_STATUS),
    :FTOL_REACHED => (MOI.LOCALLY_SOLVED, MOI.FEASIBLE_POINT),
    :XTOL_REACHED => (MOI.LOCALLY_SOLVED, MOI.FEASIBLE_POINT),
    :MAXEVAL_REACHED => (MOI.ITERATION_LIMIT, MOI.UNKNOWN_RESULT_STATUS),
    :MAXTIME_REACHED => (MOI.TIME_LIMIT, MOI.UNKNOWN_RESULT_STATUS),
)

function MOI.get(model::Optimizer, ::MOI.TerminationStatus)
    return _STATUS_MAP[model.status][1]
end

MOI.get(model::Optimizer, ::MOI.RawStatusString) = string(model.status)

function MOI.get(model::Optimizer, ::MOI.ResultCount)
    return model.status == :NOT_CALLED ? 0 : 1
end

function MOI.get(model::Optimizer, attr::MOI.PrimalStatus)
    if !(1 <= attr.result_index <= MOI.get(model, MOI.ResultCount()))
        return MOI.NO_SOLUTION
    end
    return _STATUS_MAP[model.status][2]
end

MOI.get(::Optimizer, ::MOI.DualStatus) = MOI.NO_SOLUTION

MOI.get(model::Optimizer, ::MOI.SolveTimeSec) = model.solve_time

function MOI.get(model::Optimizer, attr::MOI.ObjectiveValue)
    MOI.check_result_index_bounds(model, attr)
    return model.objective_value
end

function MOI.get(
    model::Optimizer,
    attr::MOI.VariablePrimal,
    vi::MOI.VariableIndex,
)
    MOI.check_result_index_bounds(model, attr)
    MOI.throw_if_not_valid(model, vi)
    return model.solution[vi.value]
end

function MOI.get(
    model::Optimizer,
    attr::MOI.ConstraintPrimal,
    ci::MOI.ConstraintIndex,
)
    MOI.check_result_index_bounds(model, attr)
    MOI.throw_if_not_valid(model, ci)
    return MOI.Utilities.get_fallback(model, attr, ci)
end

end # module

# Copyright (c) 2013: Steven G. Johnson and contributors
#
# Use of this source code is governed by an MIT-style license that can be found
# in the LICENSE.md file or at https://opensource.org/licenses/MIT.

#! format: off

using CEnum

# typedef double ( * nlopt_func ) ( unsigned n , const double * x , double * gradient , /* NULL if not needed */ void * func_data )
const nlopt_func = Ptr{Cvoid}

# typedef void ( * nlopt_mfunc ) ( unsigned m , double * result , unsigned n , const double * x , double * gradient , /* NULL if not needed */ void * func_data )
const nlopt_mfunc = Ptr{Cvoid}

# typedef void ( * nlopt_precond ) ( unsigned n , const double * x , const double * v , double * vpre , void * data )
const nlopt_precond = Ptr{Cvoid}

function nlopt_version(major, minor, bugfix)
    ccall((:nlopt_version, libnlopt), Cvoid, (Ptr{Cint}, Ptr{Cint}, Ptr{Cint}), major, minor, bugfix)
end

@static if v"2.9" ≤ version() < v"2.10"
    @cenum nlopt_algorithm::UInt32 begin
        NLOPT_GN_DIRECT = 0
        NLOPT_GN_DIRECT_L
        NLOPT_GN_DIRECT_L_RAND
        NLOPT_GN_DIRECT_NOSCAL
        NLOPT_GN_DIRECT_L_NOSCAL
        NLOPT_GN_DIRECT_L_RAND_NOSCAL
        NLOPT_GN_ORIG_DIRECT
        NLOPT_GN_ORIG_DIRECT_L
        NLOPT_GD_STOGO
        NLOPT_GD_STOGO_RAND
        # NLOPT_LD_LBFGS_NOCEDAL = 10
        NLOPT_LD_LBFGS
        NLOPT_LN_PRAXIS
        NLOPT_LD_VAR1
        NLOPT_LD_VAR2
        NLOPT_LD_TNEWTON
        NLOPT_LD_TNEWTON_RESTART
        NLOPT_LD_TNEWTON_PRECOND
        NLOPT_LD_TNEWTON_PRECOND_RESTART
        NLOPT_GN_CRS2_LM
        NLOPT_GN_MLSL
        NLOPT_GD_MLSL
        NLOPT_GN_MLSL_LDS
        NLOPT_GD_MLSL_LDS
        NLOPT_LD_MMA
        NLOPT_LN_COBYLA
        NLOPT_LN_NEWUOA
        NLOPT_LN_NEWUOA_BOUND
        NLOPT_LN_NELDERMEAD
        NLOPT_LN_SBPLX
        NLOPT_LN_AUGLAG
        NLOPT_LD_AUGLAG
        NLOPT_LN_AUGLAG_EQ
        NLOPT_LD_AUGLAG_EQ
        NLOPT_LN_BOBYQA
        NLOPT_GN_ISRES
        NLOPT_AUGLAG
        NLOPT_AUGLAG_EQ
        NLOPT_G_MLSL
        NLOPT_G_MLSL_LDS
        NLOPT_LD_SLSQP
        NLOPT_LD_CCSAQ
        NLOPT_GN_ESCH
        NLOPT_GN_AGS
        NLOPT_NUM_ALGORITHMS
    end
else
    @cenum nlopt_algorithm::UInt32 begin
        NLOPT_GN_DIRECT = 0
        NLOPT_GN_DIRECT_L
        NLOPT_GN_DIRECT_L_RAND
        NLOPT_GN_DIRECT_NOSCAL
        NLOPT_GN_DIRECT_L_NOSCAL
        NLOPT_GN_DIRECT_L_RAND_NOSCAL
        NLOPT_GN_ORIG_DIRECT
        NLOPT_GN_ORIG_DIRECT_L
        NLOPT_GD_STOGO
        NLOPT_GD_STOGO_RAND
        NLOPT_LD_LBFGS_NOCEDAL  # This one exists
        NLOPT_LD_LBFGS
        NLOPT_LN_PRAXIS
        NLOPT_LD_VAR1
        NLOPT_LD_VAR2
        NLOPT_LD_TNEWTON
        NLOPT_LD_TNEWTON_RESTART
        NLOPT_LD_TNEWTON_PRECOND
        NLOPT_LD_TNEWTON_PRECOND_RESTART
        NLOPT_GN_CRS2_LM
        NLOPT_GN_MLSL
        NLOPT_GD_MLSL
        NLOPT_GN_MLSL_LDS
        NLOPT_GD_MLSL_LDS
        NLOPT_LD_MMA
        NLOPT_LN_COBYLA
        NLOPT_LN_NEWUOA
        NLOPT_LN_NEWUOA_BOUND
        NLOPT_LN_NELDERMEAD
        NLOPT_LN_SBPLX
        NLOPT_LN_AUGLAG
        NLOPT_LD_AUGLAG
        NLOPT_LN_AUGLAG_EQ
        NLOPT_LD_AUGLAG_EQ
        NLOPT_LN_BOBYQA
        NLOPT_GN_ISRES
        NLOPT_AUGLAG
        NLOPT_AUGLAG_EQ
        NLOPT_G_MLSL
        NLOPT_G_MLSL_LDS
        NLOPT_LD_SLSQP
        NLOPT_LD_CCSAQ
        NLOPT_GN_ESCH
        NLOPT_GN_AGS
        NLOPT_NUM_ALGORITHMS
    end
end

function nlopt_algorithm_name(a)
    ccall((:nlopt_algorithm_name, libnlopt), Ptr{Cchar}, (nlopt_algorithm,), a)
end

function nlopt_algorithm_to_string(algorithm)
    ccall((:nlopt_algorithm_to_string, libnlopt), Ptr{Cchar}, (nlopt_algorithm,), algorithm)
end

function nlopt_algorithm_from_string(name)
    ccall((:nlopt_algorithm_from_string, libnlopt), nlopt_algorithm, (Ptr{Cchar},), name)
end

@cenum nlopt_result::Int32 begin
    NLOPT_FAILURE = -1
    NLOPT_INVALID_ARGS = -2
    NLOPT_OUT_OF_MEMORY = -3
    NLOPT_ROUNDOFF_LIMITED = -4
    NLOPT_FORCED_STOP = -5
    NLOPT_NUM_FAILURES = -6
    NLOPT_SUCCESS = 1
    NLOPT_STOPVAL_REACHED = 2
    NLOPT_FTOL_REACHED = 3
    NLOPT_XTOL_REACHED = 4
    NLOPT_MAXEVAL_REACHED = 5
    NLOPT_MAXTIME_REACHED = 6
    NLOPT_NUM_RESULTS = 7
end

function nlopt_result_to_string(algorithm)
    ccall((:nlopt_result_to_string, libnlopt), Ptr{Cchar}, (nlopt_result,), algorithm)
end

function nlopt_result_from_string(name)
    ccall((:nlopt_result_from_string, libnlopt), nlopt_result, (Ptr{Cchar},), name)
end

function nlopt_srand(seed)
    ccall((:nlopt_srand, libnlopt), Cvoid, (Culong,), seed)
end

function nlopt_srand_time()
    ccall((:nlopt_srand_time, libnlopt), Cvoid, ())
end

mutable struct nlopt_opt_s end

const nlopt_opt = Ptr{Cvoid}

function nlopt_create(algorithm, n)
    ccall((:nlopt_create, libnlopt), nlopt_opt, (nlopt_algorithm, Cuint), algorithm, n)
end

function nlopt_destroy(opt)
    ccall((:nlopt_destroy, libnlopt), Cvoid, (nlopt_opt,), opt)
end

function nlopt_copy(opt)
    ccall((:nlopt_copy, libnlopt), nlopt_opt, (nlopt_opt,), opt)
end

function nlopt_optimize(opt, x, opt_f)
    ccall((:nlopt_optimize, libnlopt), nlopt_result, (nlopt_opt, Ptr{Cdouble}, Ptr{Cdouble}), opt, x, opt_f)
end

function nlopt_set_min_objective(opt, f, f_data)
    ccall((:nlopt_set_min_objective, libnlopt), nlopt_result, (nlopt_opt, nlopt_func, Ptr{Cvoid}), opt, f, f_data)
end

function nlopt_set_max_objective(opt, f, f_data)
    ccall((:nlopt_set_max_objective, libnlopt), nlopt_result, (nlopt_opt, nlopt_func, Ptr{Cvoid}), opt, f, f_data)
end

function nlopt_set_precond_min_objective(opt, f, pre, f_data)
    ccall((:nlopt_set_precond_min_objective, libnlopt), nlopt_result, (nlopt_opt, nlopt_func, nlopt_precond, Ptr{Cvoid}), opt, f, pre, f_data)
end

function nlopt_set_precond_max_objective(opt, f, pre, f_data)
    ccall((:nlopt_set_precond_max_objective, libnlopt), nlopt_result, (nlopt_opt, nlopt_func, nlopt_precond, Ptr{Cvoid}), opt, f, pre, f_data)
end

function nlopt_get_algorithm(opt)
    ccall((:nlopt_get_algorithm, libnlopt), nlopt_algorithm, (nlopt_opt,), opt)
end

function nlopt_get_dimension(opt)
    ccall((:nlopt_get_dimension, libnlopt), Cuint, (nlopt_opt,), opt)
end

function nlopt_get_errmsg(opt)
    ccall((:nlopt_get_errmsg, libnlopt), Ptr{Cchar}, (nlopt_opt,), opt)
end

function nlopt_set_param(opt, name, val)
    ccall((:nlopt_set_param, libnlopt), nlopt_result, (nlopt_opt, Ptr{Cchar}, Cdouble), opt, name, val)
end

function nlopt_get_param(opt, name, defaultval)
    ccall((:nlopt_get_param, libnlopt), Cdouble, (nlopt_opt, Ptr{Cchar}, Cdouble), opt, name, defaultval)
end

function nlopt_has_param(opt, name)
    ccall((:nlopt_has_param, libnlopt), Cint, (nlopt_opt, Ptr{Cchar}), opt, name)
end

function nlopt_num_params(opt)
    ccall((:nlopt_num_params, libnlopt), Cuint, (nlopt_opt,), opt)
end

function nlopt_nth_param(opt, n)
    ccall((:nlopt_nth_param, libnlopt), Ptr{Cchar}, (nlopt_opt, Cuint), opt, n)
end

function nlopt_set_lower_bounds(opt, lb)
    ccall((:nlopt_set_lower_bounds, libnlopt), nlopt_result, (nlopt_opt, Ptr{Cdouble}), opt, lb)
end

function nlopt_set_lower_bounds1(opt, lb)
    ccall((:nlopt_set_lower_bounds1, libnlopt), nlopt_result, (nlopt_opt, Cdouble), opt, lb)
end

function nlopt_set_lower_bound(opt, i, lb)
    ccall((:nlopt_set_lower_bound, libnlopt), nlopt_result, (nlopt_opt, Cint, Cdouble), opt, i, lb)
end

function nlopt_get_lower_bounds(opt, lb)
    ccall((:nlopt_get_lower_bounds, libnlopt), nlopt_result, (nlopt_opt, Ptr{Cdouble}), opt, lb)
end

function nlopt_set_upper_bounds(opt, ub)
    ccall((:nlopt_set_upper_bounds, libnlopt), nlopt_result, (nlopt_opt, Ptr{Cdouble}), opt, ub)
end

function nlopt_set_upper_bounds1(opt, ub)
    ccall((:nlopt_set_upper_bounds1, libnlopt), nlopt_result, (nlopt_opt, Cdouble), opt, ub)
end

function nlopt_set_upper_bound(opt, i, ub)
    ccall((:nlopt_set_upper_bound, libnlopt), nlopt_result, (nlopt_opt, Cint, Cdouble), opt, i, ub)
end

function nlopt_get_upper_bounds(opt, ub)
    ccall((:nlopt_get_upper_bounds, libnlopt), nlopt_result, (nlopt_opt, Ptr{Cdouble}), opt, ub)
end

function nlopt_remove_inequality_constraints(opt)
    ccall((:nlopt_remove_inequality_constraints, libnlopt), nlopt_result, (nlopt_opt,), opt)
end

function nlopt_add_inequality_constraint(opt, fc, fc_data, tol)
    ccall((:nlopt_add_inequality_constraint, libnlopt), nlopt_result, (nlopt_opt, nlopt_func, Ptr{Cvoid}, Cdouble), opt, fc, fc_data, tol)
end

function nlopt_add_precond_inequality_constraint(opt, fc, pre, fc_data, tol)
    ccall((:nlopt_add_precond_inequality_constraint, libnlopt), nlopt_result, (nlopt_opt, nlopt_func, nlopt_precond, Ptr{Cvoid}, Cdouble), opt, fc, pre, fc_data, tol)
end

function nlopt_add_inequality_mconstraint(opt, m, fc, fc_data, tol)
    ccall((:nlopt_add_inequality_mconstraint, libnlopt), nlopt_result, (nlopt_opt, Cuint, nlopt_mfunc, Ptr{Cvoid}, Ptr{Cdouble}), opt, m, fc, fc_data, tol)
end

function nlopt_remove_equality_constraints(opt)
    ccall((:nlopt_remove_equality_constraints, libnlopt), nlopt_result, (nlopt_opt,), opt)
end

function nlopt_add_equality_constraint(opt, h, h_data, tol)
    ccall((:nlopt_add_equality_constraint, libnlopt), nlopt_result, (nlopt_opt, nlopt_func, Ptr{Cvoid}, Cdouble), opt, h, h_data, tol)
end

function nlopt_add_precond_equality_constraint(opt, h, pre, h_data, tol)
    ccall((:nlopt_add_precond_equality_constraint, libnlopt), nlopt_result, (nlopt_opt, nlopt_func, nlopt_precond, Ptr{Cvoid}, Cdouble), opt, h, pre, h_data, tol)
end

function nlopt_add_equality_mconstraint(opt, m, h, h_data, tol)
    ccall((:nlopt_add_equality_mconstraint, libnlopt), nlopt_result, (nlopt_opt, Cuint, nlopt_mfunc, Ptr{Cvoid}, Ptr{Cdouble}), opt, m, h, h_data, tol)
end

function nlopt_set_stopval(opt, stopval)
    ccall((:nlopt_set_stopval, libnlopt), nlopt_result, (nlopt_opt, Cdouble), opt, stopval)
end

function nlopt_get_stopval(opt)
    ccall((:nlopt_get_stopval, libnlopt), Cdouble, (nlopt_opt,), opt)
end

function nlopt_set_ftol_rel(opt, tol)
    ccall((:nlopt_set_ftol_rel, libnlopt), nlopt_result, (nlopt_opt, Cdouble), opt, tol)
end

function nlopt_get_ftol_rel(opt)
    ccall((:nlopt_get_ftol_rel, libnlopt), Cdouble, (nlopt_opt,), opt)
end

function nlopt_set_ftol_abs(opt, tol)
    ccall((:nlopt_set_ftol_abs, libnlopt), nlopt_result, (nlopt_opt, Cdouble), opt, tol)
end

function nlopt_get_ftol_abs(opt)
    ccall((:nlopt_get_ftol_abs, libnlopt), Cdouble, (nlopt_opt,), opt)
end

function nlopt_set_xtol_rel(opt, tol)
    ccall((:nlopt_set_xtol_rel, libnlopt), nlopt_result, (nlopt_opt, Cdouble), opt, tol)
end

function nlopt_get_xtol_rel(opt)
    ccall((:nlopt_get_xtol_rel, libnlopt), Cdouble, (nlopt_opt,), opt)
end

function nlopt_set_xtol_abs1(opt, tol)
    ccall((:nlopt_set_xtol_abs1, libnlopt), nlopt_result, (nlopt_opt, Cdouble), opt, tol)
end

function nlopt_set_xtol_abs(opt, tol)
    ccall((:nlopt_set_xtol_abs, libnlopt), nlopt_result, (nlopt_opt, Ptr{Cdouble}), opt, tol)
end

function nlopt_get_xtol_abs(opt, tol)
    ccall((:nlopt_get_xtol_abs, libnlopt), nlopt_result, (nlopt_opt, Ptr{Cdouble}), opt, tol)
end

function nlopt_set_x_weights1(opt, w)
    ccall((:nlopt_set_x_weights1, libnlopt), nlopt_result, (nlopt_opt, Cdouble), opt, w)
end

function nlopt_set_x_weights(opt, w)
    ccall((:nlopt_set_x_weights, libnlopt), nlopt_result, (nlopt_opt, Ptr{Cdouble}), opt, w)
end

function nlopt_get_x_weights(opt, w)
    ccall((:nlopt_get_x_weights, libnlopt), nlopt_result, (nlopt_opt, Ptr{Cdouble}), opt, w)
end

function nlopt_set_maxeval(opt, maxeval)
    ccall((:nlopt_set_maxeval, libnlopt), nlopt_result, (nlopt_opt, Cint), opt, maxeval)
end

function nlopt_get_maxeval(opt)
    ccall((:nlopt_get_maxeval, libnlopt), Cint, (nlopt_opt,), opt)
end

function nlopt_get_numevals(opt)
    ccall((:nlopt_get_numevals, libnlopt), Cint, (nlopt_opt,), opt)
end

function nlopt_set_maxtime(opt, maxtime)
    ccall((:nlopt_set_maxtime, libnlopt), nlopt_result, (nlopt_opt, Cdouble), opt, maxtime)
end

function nlopt_get_maxtime(opt)
    ccall((:nlopt_get_maxtime, libnlopt), Cdouble, (nlopt_opt,), opt)
end

function nlopt_force_stop(opt)
    ccall((:nlopt_force_stop, libnlopt), nlopt_result, (nlopt_opt,), opt)
end

function nlopt_set_force_stop(opt, val)
    ccall((:nlopt_set_force_stop, libnlopt), nlopt_result, (nlopt_opt, Cint), opt, val)
end

function nlopt_get_force_stop(opt)
    ccall((:nlopt_get_force_stop, libnlopt), Cint, (nlopt_opt,), opt)
end

function nlopt_set_local_optimizer(opt, local_opt)
    ccall((:nlopt_set_local_optimizer, libnlopt), nlopt_result, (nlopt_opt, nlopt_opt), opt, local_opt)
end

function nlopt_set_population(opt, pop)
    ccall((:nlopt_set_population, libnlopt), nlopt_result, (nlopt_opt, Cuint), opt, pop)
end

function nlopt_get_population(opt)
    ccall((:nlopt_get_population, libnlopt), Cuint, (nlopt_opt,), opt)
end

function nlopt_set_vector_storage(opt, dim)
    ccall((:nlopt_set_vector_storage, libnlopt), nlopt_result, (nlopt_opt, Cuint), opt, dim)
end

function nlopt_get_vector_storage(opt)
    ccall((:nlopt_get_vector_storage, libnlopt), Cuint, (nlopt_opt,), opt)
end

function nlopt_set_default_initial_step(opt, x)
    ccall((:nlopt_set_default_initial_step, libnlopt), nlopt_result, (nlopt_opt, Ptr{Cdouble}), opt, x)
end

function nlopt_set_initial_step(opt, dx)
    ccall((:nlopt_set_initial_step, libnlopt), nlopt_result, (nlopt_opt, Ptr{Cdouble}), opt, dx)
end

function nlopt_set_initial_step1(opt, dx)
    ccall((:nlopt_set_initial_step1, libnlopt), nlopt_result, (nlopt_opt, Cdouble), opt, dx)
end

function nlopt_get_initial_step(opt, x, dx)
    ccall((:nlopt_get_initial_step, libnlopt), nlopt_result, (nlopt_opt, Ptr{Cdouble}, Ptr{Cdouble}), opt, x, dx)
end

# typedef void * ( * nlopt_munge ) ( void * p )
const nlopt_munge = Ptr{Cvoid}

function nlopt_set_munge(opt, munge_on_destroy, munge_on_copy)
    ccall((:nlopt_set_munge, libnlopt), Cvoid, (nlopt_opt, nlopt_munge, nlopt_munge), opt, munge_on_destroy, munge_on_copy)
end

# typedef void * ( * nlopt_munge2 ) ( void * p , void * data )
const nlopt_munge2 = Ptr{Cvoid}

function nlopt_munge_data(opt, munge, data)
    ccall((:nlopt_munge_data, libnlopt), Cvoid, (nlopt_opt, nlopt_munge2, Ptr{Cvoid}), opt, munge, data)
end

# typedef double ( * nlopt_func_old ) ( int n , const double * x , double * gradient , /* NULL if not needed */ void * func_data )
const nlopt_func_old = Ptr{Cvoid}

function nlopt_minimize(algorithm, n, f, f_data, lb, ub, x, minf, minf_max, ftol_rel, ftol_abs, xtol_rel, xtol_abs, maxeval, maxtime)
    ccall((:nlopt_minimize, libnlopt), nlopt_result, (nlopt_algorithm, Cint, nlopt_func_old, Ptr{Cvoid}, Ptr{Cdouble}, Ptr{Cdouble}, Ptr{Cdouble}, Ptr{Cdouble}, Cdouble, Cdouble, Cdouble, Cdouble, Ptr{Cdouble}, Cint, Cdouble), algorithm, n, f, f_data, lb, ub, x, minf, minf_max, ftol_rel, ftol_abs, xtol_rel, xtol_abs, maxeval, maxtime)
end

function nlopt_minimize_constrained(algorithm, n, f, f_data, m, fc, fc_data, fc_datum_size, lb, ub, x, minf, minf_max, ftol_rel, ftol_abs, xtol_rel, xtol_abs, maxeval, maxtime)
    ccall((:nlopt_minimize_constrained, libnlopt), nlopt_result, (nlopt_algorithm, Cint, nlopt_func_old, Ptr{Cvoid}, Cint, nlopt_func_old, Ptr{Cvoid}, Cptrdiff_t, Ptr{Cdouble}, Ptr{Cdouble}, Ptr{Cdouble}, Ptr{Cdouble}, Cdouble, Cdouble, Cdouble, Cdouble, Ptr{Cdouble}, Cint, Cdouble), algorithm, n, f, f_data, m, fc, fc_data, fc_datum_size, lb, ub, x, minf, minf_max, ftol_rel, ftol_abs, xtol_rel, xtol_abs, maxeval, maxtime)
end

function nlopt_minimize_econstrained(algorithm, n, f, f_data, m, fc, fc_data, fc_datum_size, p, h, h_data, h_datum_size, lb, ub, x, minf, minf_max, ftol_rel, ftol_abs, xtol_rel, xtol_abs, htol_rel, htol_abs, maxeval, maxtime)
    ccall((:nlopt_minimize_econstrained, libnlopt), nlopt_result, (nlopt_algorithm, Cint, nlopt_func_old, Ptr{Cvoid}, Cint, nlopt_func_old, Ptr{Cvoid}, Cptrdiff_t, Cint, nlopt_func_old, Ptr{Cvoid}, Cptrdiff_t, Ptr{Cdouble}, Ptr{Cdouble}, Ptr{Cdouble}, Ptr{Cdouble}, Cdouble, Cdouble, Cdouble, Cdouble, Ptr{Cdouble}, Cdouble, Cdouble, Cint, Cdouble), algorithm, n, f, f_data, m, fc, fc_data, fc_datum_size, p, h, h_data, h_datum_size, lb, ub, x, minf, minf_max, ftol_rel, ftol_abs, xtol_rel, xtol_abs, htol_rel, htol_abs, maxeval, maxtime)
end

function nlopt_get_local_search_algorithm(deriv, nonderiv, maxeval)
    ccall((:nlopt_get_local_search_algorithm, libnlopt), Cvoid, (Ptr{nlopt_algorithm}, Ptr{nlopt_algorithm}, Ptr{Cint}), deriv, nonderiv, maxeval)
end

function nlopt_set_local_search_algorithm(deriv, nonderiv, maxeval)
    ccall((:nlopt_set_local_search_algorithm, libnlopt), Cvoid, (nlopt_algorithm, nlopt_algorithm, Cint), deriv, nonderiv, maxeval)
end

function nlopt_get_stochastic_population()
    ccall((:nlopt_get_stochastic_population, libnlopt), Cint, ())
end

function nlopt_set_stochastic_population(pop)
    ccall((:nlopt_set_stochastic_population, libnlopt), Cvoid, (Cint,), pop)
end

const NLOPT_MINF_MAX_REACHED = NLOPT_STOPVAL_REACHED

# Skipping MacroDefinition: NLOPT_DEPRECATED __attribute__ ( ( deprecated ) )
